// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.


package JRunMC.hlookup;

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import java.util.Random;
import javax.swing.*;
import hep.aida.*;
import hep.aida.ref.*;
import java.awt.geom.Point2D;
import java.io.IOException;


import org.jfree.ui.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.*;
import org.jfree.data.*;
import org.jfree.data.xy.*;
import org.jfree.data.contour.*;
import org.jfree.data.category.*;
import org.jfree.data.statistics.*;
import org.jfree.chart.renderer.*;
import org.jfree.chart.renderer.xy.*;
import org.jfree.chart.renderer.category.*; 
import org.jfree.chart.axis.*;
import org.jfree.chart.title.*;

/**
 * An example of how to embed a JAIDA IPlotter into your own application.
 */
public class JCanvas extends JPanel
{

      /** For serialization. */
    private static final long serialVersionUID = 60464674L;


     private  static IntervalXYDataset dataset;
//     private  static ContourDataset dataset2D;
     private  static JFreeChart chart;
     private  static JHistoPanel chartPanel;
     private  static XYSeries series;
     private  static TextTitle subm;
     private  static StatAnnotation statbox;
     private  static String stat_mess;
     private  static XYPlot xyplot;
     private  static String events="";
     private  static String mean="";
     private  static String sigma="";
     private  static boolean ShowStat=true;
     private  final  Font axisfont= new Font("Verdana", Font.BOLD, 16); 
     private  final  Font tickfont= new Font("Verdana", Font.BOLD, 14);

      /**
     * Creates Canvas .
     * 
     * @param int X-size and Y-size.
     * 
     * @return none.
     */
   public JCanvas(int xsize, int ysize)
   {
        super(new BorderLayout());
        chart = createChart(null,"Empty","h",Color.blue);
        chartPanel = new JHistoPanel(chart);
        chartPanel.setLayout(new BorderLayout());
        chartPanel.setMouseZoomable(true, false);
        chartPanel.setPreferredSize(new java.awt.Dimension(xsize,ysize));
        this.setPreferredSize(new java.awt.Dimension(xsize,ysize)); 
        this.add(chartPanel);
        this.setVisible(true);

   }


   
      /**
     * Draw canvas 1D histogram.
     *
     * @param String - how to draw ("h"-bars), Color: colors for the bars.
     *
     * @return none.
     */
   public void Draw( Histogram1D h1, String how, Color jcolor  )
   {

    dataset = null;
    JFreeChart chart = null;
    int    Bin=h1.xAxis().bins();
    double Min   =h1.xAxis().binLowerEdge(0);
    double Max   =h1.xAxis().binUpperEdge(Bin-1);
    String T= h1.title();  

    xyplot = null;
    if ( how.equals("h") || how.equals("a") || how.equals("p") ) { 
       dataset=createDataset(h1);
       chart = createChart(dataset, h1.title(), how, jcolor);
       xyplot = chart.getXYPlot();
       xyplot.getRenderer(0).setSeriesPaint(0, Color.blue);
       xyplot.getRenderer(0).setOutlinePaint(Color.black);
  //     xyplot.setBackgroundPaint(Color.lightGray);
       xyplot.setBackgroundPaint(Color.white);
//       xyplot.setDomainGridlinePaint(Color.white);
//       xyplot.setRangeGridlinePaint(Color.white);
       xyplot.setDomainCrosshairVisible(true);
       xyplot.setRangeCrosshairVisible(true);
       NumberAxis domainAxis = (NumberAxis)xyplot.getDomainAxis();
       domainAxis.setLowerBound(Min);
       domainAxis.setUpperBound(Max);
       domainAxis.setLabelFont( axisfont );
       domainAxis.setLabelFont( tickfont );
       NumberAxis rangeAxis = (NumberAxis)xyplot.getRangeAxis();
       rangeAxis.setLabelFont( axisfont );
       rangeAxis.setLabelFont( tickfont );

       xyplot.getRenderer(0).setSeriesPaint(0, Color.blue);
 
     // points with errors
   } else if (how.equals("pe") ) {

// get error bars
         HistogramRangePoints simp1 = new HistogramRangePoints(h1,1);
         chart = ChartFactory.createScatterPlot(h1.title(),
         h1.title(), "Entries", simp1, PlotOrientation.VERTICAL, false, true, false);

         xyplot = chart.getXYPlot();
         HepIntervalRenderer herender = new HepIntervalRenderer(0,2.0);
         xyplot.setRenderer(herender);
        
         NumberAxis domainAxis = (NumberAxis)xyplot.getDomainAxis();
         domainAxis.setLabelFont( axisfont );
         domainAxis.setLabelFont( tickfont );
         domainAxis.setLowerBound(Min);
         domainAxis.setUpperBound(Max);
         NumberAxis rangeAxis = (NumberAxis)xyplot.getRangeAxis();
         rangeAxis.setLabelFont( axisfont );
         rangeAxis.setLabelFont( tickfont );
         // set color
         xyplot.getRenderer(0).setSeriesPaint(0, Color.blue);

// overlay 2 histogrsm 
/*
         HistogramRangePoints simp1 = new HistogramRangePoints(h1,0);
         HistogramRangePoints simp2 = new HistogramRangePoints(h1,1);

        YIntervalRenderer  mrenderer = new YIntervalRenderer();
        NumberAxis numberaxis = new NumberAxis("Events");
        XYPlot xyplot = new XYPlot(simp1, null, numberaxis, mrenderer);
        xyplot.setRangeAxisLocation(AxisLocation.BOTTOM_OR_LEFT);
        xyplot.setDataset(1, simp2);
        CombinedDomainXYPlot combineddomainxyplot = new CombinedDomainXYPlot(new NumberAxis("Domain"));
        combineddomainxyplot.add(xyplot, 1);
        combineddomainxyplot.setOrientation(PlotOrientation.VERTICAL);
        chart =  new JFreeChart("Combined", JFreeChart.DEFAULT_TITLE_FONT, combineddomainxyplot,false);
*/
       // points with errors
   } else if (how.equals("he") ) {

// overlay 2 histogrsm
        HistogramRangePoints simp1 = new HistogramRangePoints(h1,1);
        dataset=createDataset(h1);

        HepIntervalRenderer  rhep  = new  HepIntervalRenderer(1,2.0);
        NumberAxis dAxis = new NumberAxis(T);
        NumberAxis vAxis = new NumberAxis("Entries");
        dAxis.setLowerBound(Min);
        dAxis.setUpperBound(Max);
        dAxis.setLabelFont( axisfont );
        vAxis.setLabelFont( axisfont );
        dAxis.setLabelFont( tickfont );
        vAxis.setLabelFont( tickfont );

        XYBarRenderer  rbox = new XYBarRenderer();


       XYPlot xyplot1 = new XYPlot(dataset, dAxis, vAxis, rbox);
       xyplot1.setRangeAxisLocation(AxisLocation.BOTTOM_OR_LEFT);


       xyplot1.setDataset(1, simp1);
       xyplot1.setRenderer(1, rhep);
       xyplot1.setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);
       xyplot1.getRenderer(0).setSeriesPaint(0, Color.blue);
/*
     
//        XYBarRenderer  rbox = new XYBarRenderer();   
//        final XYPlot xyplot2 = new XYPlot( dataset, dAxis, vAxis, rbox);
//        xyplot2.setRangeAxisLocation(AxisLocation.BOTTOM_OR_LEFT);


 

       final NumberAxis valueAxis = new NumberAxis("Value");
       valueAxis.setAutoRangeIncludesZero(false);  // override default

        // make a horizontally combined plot
       final CombinedRangeXYPlot comb = new CombinedRangeXYPlot(valueAxis);


        comb.add(xyplot1, 1);
        comb.add(xyplot2, 1);
        comb.setOrientation(PlotOrientation.VERTICAL);
*/
        chart =  new JFreeChart(T, JFreeChart.DEFAULT_TITLE_FONT, xyplot1,false);
        xyplot = chart.getXYPlot();
     }
  


       double mean1 = h1.mean();
       double rms1  = h1.rms();
       int    ent1  =h1.sumEntries();

       events=  "Events="+Integer.toString(ent1);
       DecimalFormat de =new DecimalFormat("0.000E00");
       mean="Mean="+de.format(mean1);
       sigma="RMS="+de.format(rms1);
 
// create statistc bar
       if (ShowStat) SetStatBox();


    subm = new TextTitle("");
    subm.setFont(new Font("Dialog", 0, 10));
    subm.setPosition(RectangleEdge.BOTTOM);
    subm.setHorizontalAlignment(HorizontalAlignment.RIGHT);
    chart.addSubtitle(subm);




     chart.setBackgroundPaint(Color.white); 
     chart.setBackgroundPaint(new
               GradientPaint(0.0F, 0.0F, Color.white, 1000F, 0.0F, Color.blue));
     chartPanel.setChart(chart);
     chartPanel.addChartMouseListener(new MyChartMouseListener(chartPanel));
     chartPanel.setDomainZoomable(true);
     chartPanel.setRangeZoomable(true);

   }







 /**
     * Draw canvas 2D histogram.
     *
     * @param String - how to draw ("h"-bars), Color: colors for the bars.
     *
     * @return none.
     */
   public void Draw( Histogram2D h1, String how, Color jcolor  )
   {

    dataset = null;
    String T=h1.title();
    JFreeChart chart = null;
    int    BinX=h1.xAxis().bins(); //  number of bins (excluding underflow and overflow bins)
    int    BinY=h1.yAxis().bins(); //  number of bins (excluding underflow and overflow bins)

     double MinX   =h1.xAxis().binLowerEdge(0);  // and the lower edge of bin i
     double MinY   =h1.yAxis().binLowerEdge(0);  // and the lower edge of bin i

     double MaxX   =h1.xAxis().binUpperEdge(BinX-1);  // and the upper edge of bin i
     double MaxY   =h1.yAxis().binUpperEdge(BinY-1);  // and the upper edge of bin i


    ContourDataset dataset2D=createDataset2D(h1);

        NumberAxis dAxis = new NumberAxis(T);
        NumberAxis vAxis = new NumberAxis("Y");
        dAxis.setLowerBound(MinX);
        dAxis.setUpperBound(MaxX);

        vAxis.setLowerBound(MinY);
        vAxis.setUpperBound(MaxY);

   ColorBar Cbar = new ColorBar("Density");
   ContourPlot xyzplot = new ContourPlot(dataset2D, dAxis, vAxis, Cbar);
   xyzplot.setColorBarLocation(RectangleEdge.RIGHT); 
   chart =  new JFreeChart(T, JFreeChart.DEFAULT_TITLE_FONT, xyzplot,false);
   
    chart.setBackgroundPaint(Color.white); 
    chartPanel.setChart(chart);


     chart.setBackgroundPaint(Color.white);
     chart.setBackgroundPaint(new
               GradientPaint(0.0F, 0.0F, Color.white, 1000F, 0.0F, Color.blue));
     chartPanel.setChart(chart);
     chartPanel.setDomainZoomable(true);
     chartPanel.setRangeZoomable(true);


    } // end drraw 2D




// set stat box 
public void SetStatBox() {

//       xyplot.removeAnnotation(statbox);

       removeStatBox(); 
       NumberAxis yAxis = (NumberAxis)xyplot.getRangeAxis();
       NumberAxis xAxis = (NumberAxis)xyplot.getDomainAxis();
       double xMin = xAxis.getLowerBound();
       double xMax = xAxis.getUpperBound();
       double yMin = yAxis.getLowerBound();
       double yMax = yAxis.getUpperBound();
       double x1= xMin + 0.65*(xMax - xMin); 
       double x2= xMin + 1.00*(xMax - xMin);
       double y1= yMin + 0.85*(yMax - yMin);
       double y2= yMin + 1.00*(yMax - yMin);

//       System.out.println(y1);
//       System.out.println(y2);
       statbox= new StatAnnotation(events,mean,sigma,x1,y1,x2,y2,
                    new BasicStroke(1.0f),Color.blue,new Color(220,220,220));
       xyplot.addAnnotation(statbox);
       ShowStat=true; 

}

// remove stat box 
public void removeStatBox() {

      ShowStat=false;
      if (statbox != null)  xyplot.removeAnnotation(statbox);

 }











// set X axis 
public void SetAxisX(String NameX, String scaleX) {

      chart=chartPanel.getChart();
      XYPlot xyplot = (XYPlot)chart.getPlot();

      if (scaleX.equals("log") ) {
      LogarithmicAxis logX = new LogarithmicAxis(NameX);
      logX.setLabelFont( axisfont );
      logX.setLabelFont( tickfont );
      logX.setAllowNegativesFlag(true);
      logX.setAutoRangeNextLogFlag(true);
    //  logX.setLog10TickLabelsFlag(true);
      xyplot.setDomainAxis(logX);
      removeStatBox();
      }


     if (scaleX.equals("lin") ) {
      NumberAxis linX = new NumberAxis(NameX);
      linX.setLabelFont( axisfont );
      linX.setLabelFont( tickfont );
      xyplot.setDomainAxis(linX);
      if (ShowStat) SetStatBox();
      }

// now set it again
      chartPanel.setChart(chart);
 }


// set Y axis
public void SetAxisY(String NameY, String scaleY) {

      chart=chartPanel.getChart();
      XYPlot xyplot = (XYPlot)chart.getPlot();

      if (scaleY.equals("log") ) {
      LogarithmicAxis logY = new LogarithmicAxis(NameY);
      logY.setLabelFont( axisfont );
      logY.setLabelFont( tickfont );
      logY.setAllowNegativesFlag(true);
      logY.setAutoRangeNextLogFlag(true);
    //  logY.setLog10TickLabelsFlag(true);
      xyplot.setRangeAxis(logY);
      removeStatBox();
      }

      if (scaleY.equals("lin") ) {
      NumberAxis linY = new NumberAxis(NameY); 
      linY.setLabelFont( axisfont );
      linY.setLabelFont( tickfont );
      xyplot.setRangeAxis(linY);
      if (ShowStat) SetStatBox();
      }
// now set it again
      chartPanel.setChart(chart);

 }


// save JCanvas  
public void SaveJCanvas() {

            try {
                chartPanel.doSaveAs();
            }
            catch (IOException e) {
                e.printStackTrace();
            }

}

// save JCanvas
public void SaveJCanvasPDF() {

            try {
                chartPanel.doSaveAsPDF();
            }
            catch (IOException e) {
                e.printStackTrace();
            }

}





// print JCanvas  
public void PrintJCanvas() {

            chartPanel.createChartPrintJob();
}


// edit canvas 
public void EditJCanvas() {
           chartPanel.attemptEditChartProperties();
}


/**
     * Creates a sample dataset.
     *
     * @return A sample dataset.
     */
private  static IntervalXYDataset createDataset(Histogram1D h1) { 



   int    Bin=h1.xAxis().bins(); //  number of bins (excluding underflow and overflow bins)
   double Min   =h1.xAxis().binLowerEdge(0);  // and the lower edge of bin i
   double BinWidth =h1.xAxis().binWidth(0);      // and its width
   double Max  =h1.xAxis().binUpperEdge(Bin-1);  // and its upper edge



     XYSeries series = new XYSeries(h1.title());

//     System.out.println("Min="+Min);
//     System.out.println("Max="+Max);

    for (int i=0; i<Bin; i++) {
     double dd=Min+BinWidth*i;
     double hh=h1.binEntries(i);
     series.add(dd+0.5*BinWidth, hh);

     }
       XYSeriesCollection dataset = new XYSeriesCollection(series);
       XYBarDataset XYDATA= new XYBarDataset(dataset, BinWidth);

       return XYDATA;
    }



/**
     * Creates 2D data set .
     *
     * @return A sample chart.
     */


private  static  ContourDataset createDataset2D(Histogram2D h1) {


   int    BinX=h1.xAxis().bins(); //  number of bins (excluding underflow and overflow bins)
   int    BinY=h1.yAxis().bins(); //  number of bins (excluding underflow and overflow bins)
 
   double MinX   =h1.xAxis().binLowerEdge(0);  // and the lower edge of bin i
   double MinY   =h1.yAxis().binLowerEdge(0);  // and the lower edge of bin i

   double MaxX   =h1.xAxis().binUpperEdge(BinX-1);  // and the lower edge of bin i
   double MaxY   =h1.yAxis().binUpperEdge(BinY-1);  // and the lower edge of bin i

   double BinWidthX =h1.xAxis().binWidth(0);      // and its width
   double BinWidthY =h1.yAxis().binWidth(0);      // and its width


     int AllMax=BinX*BinY; 
     Double xValues[] = new Double[AllMax];
     Double yValues[] = new Double[AllMax];
     Double zValues[] = new Double[AllMax];

    int nn=0;
    for (int i=0; i<BinX; i++) {
      for (int j=0; j<BinY; j++) {

     double dX=MinX+BinWidthX*i;
     double dY=MinY+BinWidthY*j;
 
      double hh=h1.binEntries(i,j);
      xValues[nn]=dX+0.5*BinWidthX;   
      yValues[nn]=dY+0.5*BinWidthY;
      zValues[nn]=hh;
      nn++;
     }
       }

       DefaultContourDataset dataset2D= new DefaultContourDataset();
       dataset2D.initialize(xValues,yValues, zValues);
 
    //   XYZBarDataset XYZDATA= new XYZBarDataset(dataset2D, BinWidth);


       return dataset2D;


    }















/**
     * Creates a sample chart.
     *
     * @param dataset  the dataset.
     *
     * @return A sample chart.
     */
     private JFreeChart createChart(IntervalXYDataset dataset, 
                                    String T, 
                                    String how, 
                                    Color jcolor) {


     JFreeChart chart = null;

       if ( how.equals("h") ) {
            chart = ChartFactory.createHistogram(
            T,
            T,
            "Entries",
            dataset,
            PlotOrientation.VERTICAL,
            false,
            true,
            false
        );

        chart.setBackgroundPaint(Color.white);
        XYPlot plot = (XYPlot)chart.getPlot();
        XYBarRenderer  renderer = (XYBarRenderer) plot.getRenderer();
        renderer.setSeriesPaint(0, jcolor, false);

        renderer.setSeriesOutlinePaint(0, Color.orange);
        renderer.setItemLabelsVisible(true);

     } else if ( how.equals("a") ) {
            chart = ChartFactory.createXYAreaChart(
            T,
            T,
           "Entries",
            dataset,
            PlotOrientation.VERTICAL,
            false,
            true,
            false
        );
      } else if ( how.equals("p") ) {
            chart = ChartFactory.createScatterPlot(
            T,
            T,
           "Entries",
            dataset,
            PlotOrientation.VERTICAL,
            false,
            true,
            false
        );
     }


        return chart;
    }


static class MyChartMouseListener
        implements ChartMouseListener
    {

        public void chartMouseClicked(ChartMouseEvent chartmouseevent)
        {
            int i = chartmouseevent.getTrigger().getX();
            int j = chartmouseevent.getTrigger().getY();
            Point2D point2d = chartPanel.translateScreenToJava2D(new Point(i, j));
            XYPlot xyplot = (XYPlot)chartPanel.getChart().getPlot();
            ChartRenderingInfo chartrenderinginfo = chartPanel.getChartRenderingInfo();
            java.awt.geom.Rectangle2D rectangle2d = chartrenderinginfo.getPlotInfo().getDataArea();
            double d = xyplot.getDomainAxis().java2DToValue(point2d.getX(), rectangle2d, xyplot.getDomainAxisEdge());
            double d1 = xyplot.getRangeAxis().java2DToValue(point2d.getY(), rectangle2d, xyplot.getRangeAxisEdge());
/*
            ValueAxis valueaxis = xyplot.getDomainAxis();
            ValueAxis valueaxis1 = xyplot.getRangeAxis();
            double d2 = valueaxis.valueToJava2D(d, rectangle2d, xyplot.getDomainAxisEdge());
            double d3 = valueaxis1.valueToJava2D(d1, rectangle2d, xyplot.getRangeAxisEdge());
            Point point = chartPanel.translateJava2DToScreen(new java.awt.geom.Point2D.Double(d2, d3));
            System.out.println("Mouse coordinates are (" + i + ", " + j + "), in data space = (" + d + ", " + d1 + ").");
            System.out.println("--> (" + point.getX() + ", " + point.getY() + ")");
*/

      DecimalFormat de =new DecimalFormat("0.00E00");
      String x="x="+de.format(d);
      String y=";  y="+de.format(d1);
      String all=""+x+y;
      subm.setText(all);

        }

        public void chartMouseMoved(ChartMouseEvent chartmouseevent)
        {
        }

     //   ChartPanel panel;

        public MyChartMouseListener(JHistoPanel chartpanel)
        {
            chartPanel = chartpanel;
        }
    }


}
