// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *

package JRunMC.ui;

import JRunMC.util.*;

import java.awt.Frame;
import java.awt.Toolkit;
import java.net.URL;
import java.util.*;
import java.lang.*;
import java.io.*;


public class Main{


    protected static SplashScreen splashScreen;
    private static int countCallsToAdvance = 0;
    private static int splashProgressLength = 10;
    private static long lastSplashAdvanceTime = System.currentTimeMillis();
    private static long splashAdvanceTimeDiff = 0;

    public static void main(String[] args) {


        // Read the image data and open the splash screen
        // ----------------------------------------------
            try {
            splashScreen = new SplashScreen( Options.getOption("jrunmc.version")  );
            splashScreen.setProgressLength(splashProgressLength);
            } catch (Exception e) {
            //if an error gets here, we want to know about it.
            System.out.println("Error to get splash screen");
            e.printStackTrace();
            System.exit(0);
            }


// initialisation of Global parameters 
         SetEnv.init(); 
           splashScreenAdvance("Enviroment..");


// initialisation of available MC models
         SetMC.init(); SetMC.FillMCexe(); 
            splashScreenAdvance("MC settings");


// initialisation of Global parameters
         SetIni.init();
            splashScreenAdvance("Global preferences");

// initialisation of Global parameters
        SetPref.init();  SetPref.Read();
             splashScreenAdvance("Preferences");

// initialisation of Global GUI components 
         Global.init();
            splashScreenAdvance("Initialisation..");


// find RMC files 
          SetRMC.init(); SetRMC.Read(); SetRMC.LoadAll(); // load infor from all RMC 
            splashScreenAdvance("Set RMC modules..");


// read options
        Options.init();
           splashScreenAdvance("Set options..");

 
        ResourceLoader.init( "JRunMC/resources/");
           splashScreenAdvance("Set preferences..");


// clean old TMP and PIPE files
          // milisec corresponding to 10 days
          if (SetEnv.RUNDIRwin32.equals("not set") == false ||
              SetEnv.RUNDIR.equals("not set") == false ) { 
           long  delay=864000000;
           TMPcleaner.clean( delay ); 
          }
          splashScreenAdvance("Clean TMP files..");


// start apllication
       int w=Options.getIntOption( "frame.width" );
       int h=Options.getIntOption( "frame.height" );


  String pathTObin = SetEnv.RUNDIR+File.separator+"proj";
  if (SetEnv.OSsys.equals("windows") )
         pathTObin =SetEnv.RUNDIRwin32+File.separator+"proj";

  File f1= new File(pathTObin);


   int nn=0;
   String namemc="none";

    if (f1.isDirectory()) {
     String s[]=f1.list();
     for (int i=0; i<s.length; i++) {
         File f=new File (pathTObin+File.separator+s[i]);

         if (f.isFile()) {
             if ( s[i].endsWith(".mc")
               && f.length()>0) { // for windows, do not pick up runmc.lnk
                  namemc=pathTObin + File.separator+s[i]; 
                  nn++;
       } }
     } 
     }   

     splashScreenAdvance("Start GUI..");
     if (nn>1) {
        System.out.println("--> Error: there are more than 2 *.mc files detected in $RUNMC/proj");
        System.out.println("--> Load one MC file manually!");
        namemc="none"; 
     } 


      if (args.length == 0) Global.mainFrame = new JRunMC( namemc );
      if (args.length > 0)  Global.mainFrame = new JRunMC(args[0]);
      splashScreen.dispose();

  }


  public static void splashScreenAdvance(String mess) {
        countCallsToAdvance++;
        splashScreen.advance(mess);

        //TODO: improve the progress bars divisions.
        //debugging which calls to advance need more advance calls in their lower objects
        //so far, setLookAndFeel and SDMFrame take the longest
        if ((System.currentTimeMillis() - lastSplashAdvanceTime) > splashAdvanceTimeDiff) {
            //Log.out("Advance Splash progress for # " + countCallsToAdvance + " : time = " + lastSplashAdvanceTime);
            splashAdvanceTimeDiff = System.currentTimeMillis() - lastSplashAdvanceTime;
        }

        lastSplashAdvanceTime = System.currentTimeMillis();
    }






}
