using namespace std;

#include "CLHEP/config/CLHEP.h"
#include "CLHEP/Vector/LorentzVector.h"
#include <vector>
extern char* getname(int PID);


   class particle {
    public:
           HepLorentzVector p; // 4-momenta   
           HepLorentzVector v; // vertex inforamtion  
           double           mass;        // mass  
           int              pos;         // position in HEPEVT 
           int              id;          // identity (particle data group) 
           char*            name() {return getname(id); }; // get particle name  
           int              charge3;     // charge times 3 
           int              status;      // status of entry
           int              mother;      // mother  
           int              mother2;     // point to second mother  
           int              daughter;    // daughter 
           int              daughter2;   // point to second daughter 
           };


    class jet{
    public:
           HepLorentzVector p;         // 4-momenta
           int              in;        // number of particles in this jet 
           };

// event record for Monte Carlo events  
// class to get lists of articles as they are in HEPEVT common 
    class heplist {
        public:
          heplist();                       // constructor 
          ~heplist();                      // destructor  
          HepLorentzVector beam1;          // beam 1 
          int id1;                         // PID of this particle           
          HepLorentzVector beam2;          // beam 2 
          int id2;                         // PID of this particle  
          HepLorentzVector boson;          // Px,Py,Pz,E of exchange boson 
          int idboson;                     // PID of boson  
          HepLorentzVector lepton;         // Px,Py,Pz,E of ougoing lepton (DIS) 
          int idlepton;                    // PID of lepton 
          // information on separate particles
          vector<particle>  HP;            // before any selection, pure HEPEVT record 
          // information on separate particles  
          vector<particle>  PP;            // vector with particles (after selection (stable, partons, etc.) 
          // information on event 
          double      PTtot,PZtot,Etot;    // event PT, PZ,Etot 
          // information on jets 
          vector<jet> PJ;                  // vector with jets (made up from PP) 
          // 
          void   fill_HEPEVT();     // fill all particles from HEPEVT. Always does this, selection cannt affect  
          // below are stuff when specific final sate is required ..  
          void   fill_All();       // fill all particles from HEPEVT  
          void   fill_ALLstable(); // fill stable particles from HEPEVT
          void   fill_Partons();   // fill partons from HEPEVT
          void   fill_CHARGEDstable();   // fill partons from HEPEVT
          int   set_jetPtEta();        // set Pt and Eta cuts on particles
          int   set_particlePtEta();   // set Pt and Eta cuts on jets
          // transformations for jets
          int   set_jetLABtoHCMframe();         // move jets to the HCM frame 
          int   set_jetHCMtoLABframe();         // move jets to the lab from HCM frame
          int   set_jetLABtoBREITframe();        // move jets to  Breit frame
          int   set_jetBREITtoLABframe();         // move jets to lab frame from Breit frame
          // for sepate particles transformation
          int   set_particleLABtoHCMframe();         // move jets to the HCM frame
          int   set_particleHCMtoLABframe();         // move jets to the lab from HCM frame
          int   set_particleLABtoBREITframe();        // move jets to  Breit frame
          int   set_particleBREITtoLABframe();         // move jets to lab frame from Breit frame
          int   set_JADEjets();         // move to the JADE jets 
          int   set_DURHAMjets();         // move to the Durham jets
          int   set_KTjets();         // move to the KT long invariant  jets
         };
