/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//RunJavaDialog - this class displays the dialog box for setting the Java interpreter options.
//These options are then passed as a string to the main program by the setJavaRunOptions method.
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk


package com.javac;

import java.awt.AWTEvent;
import java.awt.Insets;
import java.awt.Font;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.BorderLayout;

import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.ItemEvent;


import javax.swing.text.Document;

import java.io.File;

import javax.swing.JFrame;

import com.jpe.jpe;
import com.utils.*;

public class RunJavaDialog extends JDialog
	implements ActionListener, ItemListener
{


		private jpe window;
		private JButton Cancel, OK, Open, Open2;
		private JTextField classpjtf, filejtf;
		private JCheckBox javacheck, verbcheck, javawcheck, dcheck, jarcheck, cpcheck;
		private String Options, gap, classPath, classFile;
		private boolean javaCheck, javawCheck, verbCheck, jarCheck, cpCheck;
	  private ButtonGroup btgrp;
	  private String fileSep = System.getProperty("file.separator");
	  private Utils Utils;
	  private Icon open = new ImageIcon("images" + fileSep + "open.gif");
	  private JFileChooser jFileChooser = new JFileChooser();
	  private JFileChooser jfc;
	  private File dir;


  // Constructor
  public RunJavaDialog(jpe window)
  {

    super(window, "Java Interpreter Options", false);

    this.window = window;
    this.setResizable(false);

		Utils = new Utils(window);


    JPanel topbutPanel = new JPanel();
		topbutPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		topbutPanel.add(javacheck = createCheckBox("java"));
		topbutPanel.add(javawcheck = createCheckBox("javaw"));
		topbutPanel.add(cpcheck = createCheckBox("-classpath"));

		btgrp = new ButtonGroup();
		btgrp.add(javacheck);
		btgrp.add(javawcheck);


		//topbutPanel.add(nowarncheck = createCheckBox("-nowarn"));


		JPanel midbutPanel = new JPanel();
		midbutPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		midbutPanel.add(verbcheck = createCheckBox("-verbose"));
		midbutPanel.add(jarcheck = createCheckBox("-jar"));
		//midbutPanel.add(ocheck = createCheckBox("-O"));


    JPanel botbutPanel = new JPanel();
    botbutPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
		botbutPanel.add(OK = createButton("OK"));
		botbutPanel.add(Cancel = createButton("Cancel"));


    // Create and add the buttons to the buttonPane
    // Create the dialog button panel
    JPanel buttonPane = new JPanel();
    buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.Y_AXIS));
    buttonPane.add(Box.createVerticalGlue());
    buttonPane.add(topbutPanel);
    buttonPane.add(Box.createVerticalGlue());
		buttonPane.add(midbutPanel);
		buttonPane.add(Box.createVerticalGlue());
    buttonPane.add(botbutPanel);
    getContentPane().add(buttonPane, BorderLayout.SOUTH);

    // Code to create the data input panel...
    JPanel dataPane = new JPanel();
    dataPane.setBorder(BorderFactory.createCompoundBorder(
			BorderFactory.createLineBorder(Color.blue),
			BorderFactory.createEmptyBorder(5, 10, 5, 10)));
    GridBagLayout gbLayout = new GridBagLayout();
    dataPane.setLayout(gbLayout);
    GridBagConstraints constraints = new GridBagConstraints();


		JLabel spacer = new JLabel("  ");
		JLabel spacer2 = new JLabel("    ");
		JPanel Spacer = new JPanel();
		JPanel Spacer2 = new JPanel();
		Spacer.add(spacer);
		Spacer2.add(spacer2);

    JLabel classplabel = new JLabel("-classpath");
		JLabel dirlabel = new JLabel("   .class file");
		//JLabel sourcelabel = new JLabel("  -sourcepath");
    JPanel Labels = new JPanel();
    Labels.setLayout(new FlowLayout(FlowLayout.CENTER));

		Labels.add(spacer);
    Labels.add(classplabel);
		Labels.add(Spacer);
		Labels.add(Spacer2);
    Labels.add(dirlabel);
		//Labels.add(Spacer);

		//Labels.add(sourcelabel);

    getContentPane().add(Labels, BorderLayout.NORTH);

    JPanel txtField = new JPanel();
		txtField.setLayout(new FlowLayout(FlowLayout.CENTER));
    txtField.add(classpjtf= new JTextField(10));
		txtField.add(Open2 = createButton(open, "browse"));
		txtField.add(filejtf= new JTextField(10));
		txtField.add(Open = createButton(open, "browse"));
    gbLayout.setConstraints(txtField, constraints);
    dataPane.add(txtField);

    getContentPane().add(dataPane, BorderLayout.CENTER);
    pack();
    setVisible(false);

		classpjtf.setEnabled(false);
		cpCheck = false;

		Options = new String();
		gap = new String(" ");
		jarCheck = false;
		javawCheck = false;
		javacheck.setSelected(true);
		javaCheck = true;
		verbCheck = false;

		Open2.setEnabled(false);


  }



	JButton createButton(String label)
	{
		JButton button = new JButton(label);
		button.setPreferredSize(new Dimension(75,20));
		button.addActionListener(this);
		return button;
	}

	JButton createButton(Icon icon, String tooltip)
	{
		JButton button = new JButton(icon);
		button.setToolTipText(tooltip);
		button.addActionListener(this);
		button.setPreferredSize(new Dimension(23,20));
		return button;
	}

	JCheckBox createCheckBox(String label)
	{
		JCheckBox jcb = new JCheckBox(label);
		jcb.addItemListener(this);
		return jcb;
	}



	public void itemStateChanged(ItemEvent e)
	{
		if(javacheck.isSelected())
		{
			javaCheck = true;
			javawCheck = false;
		}else {
			javaCheck = false;
		  javawCheck = true;}

		if(javawcheck.isSelected())
		{
			javawCheck = true;
			javaCheck = false;
			}else {
				javawCheck = false;
				javaCheck = true; }

		if(jarcheck.isSelected())
		{
			jarCheck = true;
		}else jarCheck = false;


		if(verbcheck.isSelected())
		{
			verbCheck = true;
		}else verbCheck = false;

		if(cpcheck.isSelected())
		{
			cpCheck = true;
			classpjtf.setEnabled(true);
			Open2.setEnabled(true);
		}else {
			cpCheck = false;
			classpjtf.setText(null);
			classpjtf.setEnabled(false);
			Open2.setEnabled(false);
		}

	}

	public void actionPerformed(ActionEvent e)
	{
		Object source = e.getSource();

		if (e.getSource() == Open2) {
			jFileChooser.isDirectorySelectionEnabled();
		  jFileChooser.setFileSelectionMode(1);
			if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{
				classpjtf.setText(jFileChooser.getSelectedFile().getPath());
				dir = (jFileChooser.getCurrentDirectory());

			} this.repaint();
		}

		if (e.getSource() == Open) {

			 jfc= new JFileChooser(dir);

			if (jfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{

				File f = new File(jfc.getSelectedFile().getPath());
				filejtf.setText(f.getName());
			} this.repaint();
		}



		if(source == OK)
		{

			if(javaCheck)
			{ Options = "java";}

			if(javawCheck)
			{ Options = "javaw";}

			if(jarCheck)
			{ Options = Options + gap + "-jar";}

			if(verbCheck)
			{ Options = Options + gap + "-verbose";}

			if(cpCheck) {

			classPath = classpjtf.getText();
			File f = new File(classPath);

			if(!f.exists())
			{
				Utils.userMessage("Attention", classPath + " is not a valid classpath!", 2);
				Options = Options;
				return;
			}else{
				classPath = classpjtf.getText();
				classPath.trim();
				Options = Options + gap + "-cp" + gap + classPath; }

			}

			File f = null;
			classFile = filejtf.getText();
			if(cpCheck)
			f = new File(classPath + fileSep + classFile);
			else {f = new File(classFile); }

			if(!f.exists())
			{
				Utils.userMessage("Attention", classFile + " is not a valid .class file!", 2);
				Options = Options;
				return;
			}else{
				classFile = filejtf.getText();
				classFile.trim();
				classFile = f.getName().substring(0, f.getName().length()-6);
				Options = Options + gap + classFile; }




			if(Options != null) {
				if ((Options.startsWith("java"))||(Options.startsWith("javaw"))) {
				window.setJavaRunOptions(Options);
					} else
				Utils.userMessage("Attention", "Please specify either java or javaw", 2);


        }

			else
			{
				Options = "";
				window.setJavaRunOptions(Options);
			}

			setVisible(false);
		}


		else if(source == Cancel)
		{
			setVisible(false);
		}
	}


}

