/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



// Options.java - implements an options dialog - not currently used by program
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk
package com.misc;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;

import com.jpe.jpe;


public class Options extends JDialog
                 implements ActionListener, ItemListener
{
  // Constructor
  public Options(jpe win)
  {

    super(win, "EditorOptions", false);

    this.win = win;
    this.setResizable(false);
		this.setSize(200, 350);

		Container contentPane = getContentPane();

		editorPanel = new JPanel();
		editorPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		gutterPanel = new JPanel();
		gutterPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

		caretPanel = new JPanel();
		caretPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Caret"));

		caretPanel.setLayout(new BoxLayout(caretPanel, BoxLayout.Y_AXIS));
		caretPanel.add(jcbBlockCaret = createCheckBox("Block Caret"));
		caretPanel.add(jcbBlinkCaret = createCheckBox("Blink Caret"));
		caretPanel.add(jbtCaretColor = createButton("Color"));

		linePanel = new JPanel();
		linePanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Line Highlight"));

		linePanel.setLayout(new BoxLayout(linePanel, BoxLayout.Y_AXIS));
		linePanel.add(caret1 = createCheckBox("Line Highlight"));
		linePanel.add(caret2 = createCheckBox("caret2"));
		linePanel.add(caret3 = createCheckBox("Selection Color"));


		delimPanel = new JPanel();
		delimPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Delimeter"));

		delimPanel.setLayout(new BoxLayout(delimPanel, BoxLayout.Y_AXIS));
		delimPanel.add(caret1 = createCheckBox("caret1"));
		delimPanel.add(caret2 = createCheckBox("caret2"));
		//delimPanel.add(caret3 = createCheckBox("caret3"));

		eolPanel = new JPanel();
		eolPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "EOL Markers"));

		eolPanel.setLayout(new BoxLayout(eolPanel, BoxLayout.Y_AXIS));
		eolPanel.add(caret1 = createCheckBox("caret1"));
		eolPanel.add(caret2 = createCheckBox("caret2"));
		//eolPanel.add(caret3 = createCheckBox("caret3"));

		invalPanel = new JPanel();
		invalPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Invalid Line Markers"));

		invalPanel.setLayout(new BoxLayout(invalPanel, BoxLayout.Y_AXIS));
		invalPanel.add(caret1 = createCheckBox("caret1"));
		invalPanel.add(caret2 = createCheckBox("caret2"));
		//invalPanel.add(caret3 = createCheckBox("caret3"));

		editorPanel.add(caretPanel);
		editorPanel.add(linePanel);
		editorPanel.add(delimPanel);
		editorPanel.add(eolPanel);
		editorPanel.add(invalPanel);


		gutWidthPanel = new JPanel();
		gutWidthPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Gutter width"));

		gutWidthPanel.setLayout(new BoxLayout(gutWidthPanel, BoxLayout.Y_AXIS));
		gutWidthPanel.add(caret1 = createCheckBox("caret1"));
		gutWidthPanel.add(caret2 = createCheckBox("caret2"));
		gutWidthPanel.add(caret3 = createCheckBox("caret3"));

		gutColorPanel = new JPanel();
		gutColorPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Colors"));

		gutColorPanel.setLayout(new BoxLayout(gutColorPanel, BoxLayout.Y_AXIS));
		gutColorPanel.add(caret1 = createCheckBox("caret1"));
		gutColorPanel.add(caret2 = createCheckBox("caret2"));
		gutColorPanel.add(caret3 = createCheckBox("caret1"));


		gutFontPanel = new JPanel();
		gutFontPanel.setBorder(BorderFactory.createTitledBorder(
		BorderFactory.createEtchedBorder(), "Font"));

		gutFontPanel.setLayout(new BoxLayout(gutFontPanel, BoxLayout.Y_AXIS));
		gutFontPanel.add(caret1 = createCheckBox("caret1"));
		gutFontPanel.add(caret2 = createCheckBox("caret2"));
		//delimPanel.add(caret3 = createCheckBox("caret3"));

		gutterPanel.add(gutWidthPanel);
		gutterPanel.add(gutColorPanel);
		gutterPanel.add(gutFontPanel);

		jtp = new JTabbedPane();
		jtp.addTab("Editor", null, editorPanel);
		jtp.addTab("Gutter", null, gutterPanel);

		JPanel topbutPanel = new JPanel();
		topbutPanel.setLayout(new FlowLayout(FlowLayout.LEFT));


       JPanel botbutPanel = new JPanel();
        botbutPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
		botbutPanel.add(OK = createButton("OK"));
		botbutPanel.add(Cancel = createButton("Cancel"));

        getContentPane().setLayout(new BorderLayout());
		getContentPane().add(topbutPanel, BorderLayout.NORTH);
		getContentPane().add(jtp, BorderLayout.CENTER);
		getContentPane().add(botbutPanel, BorderLayout.SOUTH);

    pack();
    setVisible(false);


  }



    JButton createButton(String label)
    {
      JButton button = new JButton(label);
      button.setPreferredSize(new Dimension(75,20));
      button.addActionListener(this);
      return button;
    }

		JCheckBox createCheckBox(String label)
    {
      JCheckBox jcb = new JCheckBox(label);
      jcb.addItemListener(this);
      return jcb;
    }



    public void itemStateChanged(ItemEvent e)
     {


     }


    public void actionPerformed(ActionEvent e)
    {
      Object source = e.getSource();





      if(source == Cancel)
       {
        setVisible(false);
       }
     }



    private jpe win;
    private JButton Cancel, OK;
	private JTabbedPane jtp;
	private JPanel editorPanel, gutterPanel, caretPanel, delimPanel, linePanel, eolPanel,
		    invalPanel;
	private JPanel gutWidthPanel, gutColorPanel, gutFontPanel;
	private JCheckBox caret1, caret2, caret3, jcbBlockCaret, jcbBlinkCaret, jcbDelimCheck;
	private JButton jbtCaretColor, jbtDelimColor;



}

