// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

// set preferences for RMC info file
import java.io.*;
import java.util.*;
import java.text.*;
import java.util.zip.*;
import java.util.jar.*;
import java.lang.*;
import java.util.prefs.*;

   public class  SetRMC{


// new stuff
    public static Vector<String> files;
    public static Vector<String> group;
    public static Vector<String> author;
    public static Vector<String> describe;
    public static Vector<String> sdescribe;
    public static Vector<String> lastmodified;
    public static Vector<String> title;
    public static Vector<String> contact;
    private static String path;

// text
    private static String textjTitle="";
    private static String textjGroup="";
    private static String textjShortDescription="";
    private static String textjAuthor="";
    private static String textjContact="";
    private static String textjLastModified="";
    private static String textjDescription="";
    private static TreeSet<String> set;
 


// initialisation 
    public static void init(){


              path=SetEnv.RUNDIR+File.separator+"archive";
              if (SetEnv.OSsys.equals("windows") )
                   path =SetEnv.RUNDIRwin32+File.separator+"archive";

              group = new Vector<String>();
              files = new Vector<String>();
              author= new Vector<String>();
              title= new Vector<String>();
              describe= new Vector<String>();
              sdescribe= new Vector<String>();
              lastmodified= new Vector<String>();
              contact= new Vector<String>();
              set = new TreeSet<String>();

       }



// read RMC files
 public static void Read(){


//  clear 
     files.clear();
     set.clear();

     File f1= new File(path);
     int nn=0;


    if (f1.isDirectory()) {

     String s[]=f1.list();

     for (int i=0; i<s.length; i++) {
         File f=new File (path+File.separator+ s[i]);
         if (!f.isDirectory() ) {
             if ( s[i].endsWith(".rmc")
                  && s[i].length()>7) {
                  String ss=StringUtil.replace(s[i], ".rmc", "");
                   set.add(new String(ss));
        }
       }
      }
   } 


// put to vector
    Iterator it = set.iterator();
    while (it.hasNext() ) {
        Object elem= it.next();
       files.addElement( elem.toString() );
    } 


 } // end init 
     

  public static void LoadAll(){



// load 
     author.clear();
     title.clear();
     describe.clear();
     sdescribe.clear();
     lastmodified.clear();
     group.clear();
     contact.clear();



    for (int i=0; i<files.size(); i++) {

    String f1= path+File.separator+(String)SetRMC.files.elementAt(i)+".rmc"; 
    String f2= "proj/"+SetPref.shortName; 

//    System.out.println( "Open file:"+f1 );
//    System.out.println( "Open node:"+f2 );

 // get information
        textjTitle = "";
        textjShortDescription = "";
        textjContact = "";
        textjLastModified = "";
        textjAuthor = "";
        textjGroup = "";
        textjDescription = "";   
     try {
     JarFile zf = new JarFile(f1);

//    InputStream is = zf.getInputStream(entry);
    try {
      //   is = new BufferedInputStream(new FileInputStream( f ));

        JarEntry entry = zf.getJarEntry( f2  );

//         System.out.println( f1+" "+f2 );
        
       // if it's found
       if (entry != null ) { 
         InputStream is = zf.getInputStream(entry);
         try {
         Preferences.importPreferences(is);

// get information
         textjTitle =  SetPref.prefs.get(SetPref.keyjTitle,"not set");
         textjShortDescription = SetPref.prefs.get(SetPref.keyjShortDescription, "not set");
         textjContact = SetPref.prefs.get(SetPref.keyjContact, "not set");
         textjLastModified = SetPref.prefs.get(SetPref.keyjLastModified, "no set");
         textjAuthor = SetPref.prefs.get(SetPref.keyjAuthor, "not set");
         textjGroup = SetPref.prefs.get(SetPref.keyjGroup, "not set");
         textjDescription = SetPref.prefs.get(SetPref.keyjDescription, "not set");


         } catch (InvalidPreferencesFormatException e) {
         } catch (IOException e) {
         System.out.println( "Error in importing preferences!" );
         }
      } 
 

    } catch (FileNotFoundException e) {
         System.out.println( "File not found!" );
    }

       } catch (IOException e) { 
             // System.out.println( "RMC File not found!" );  
       }


// now add to vectors
    title.addElement( textjTitle.trim() );
    group.addElement( textjGroup.trim() );
    contact.addElement( textjContact.trim() );
    author.addElement( textjAuthor.trim() );
    describe.addElement( textjDescription.trim() ); 
    sdescribe.addElement( textjShortDescription.trim() ); 
    lastmodified.addElement( textjLastModified.trim() );

 // build new group from all RMC 
    String sw=textjGroup.trim();
    if (sw.length()>0) SetEnv.ListGroup.add( sw );



    } 
   
 } // end  LoadAll 


}                  
                  
 
