CDECK  ID>, HWEFIN.
*CMZ :-        -15/07/02  17.56.53  by  Peter Richardson
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWEFIN
C-----------------------------------------------------------------------
C     TERMINAL CALCULATIONS ON ELEMENTARY PROCESS
C     Modified 28/03/01 by BRW to handle negative weights
C     Modified 15/07/02 by PR for Les Houches Accord 
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I
      DOUBLE PRECISION RNWGT,SPWGT,ERWGT
C--Les Houches Common Block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
      IF(TAUDEC.EQ.'TAUOLA') CALL HWDTAU(2,0,0.0D0)
      IF (NWGTS.EQ.0) THEN
        WRITE (6,1)
        WRITE (6,10)
   10   FORMAT(10X,'NO WEIGHTS GENERATED')
        RETURN
      ENDIF
C--output Les Houches common block information
      IF(IPROC.LE.0) THEN
C--WRITE THE HEADER
        WRITE(6,13) 
        WRITE(6,14)
C--FOR THE FIRST WEIGHT OPTION CALCULATE THE CROSS SECTION
        IF(ABS(IDWTUP).EQ.1) THEN
          DO I=1,NPRUP
            RNWGT     = 1.0D0/DBLE(LHIWGT(I))
            LHXSCT(I) = LHWGT(I)*RNWGT
            LHXERR(I) = SQRT(MAX(LHWGTS(I)*RNWGT-LHXSCT(I)**2,ZERO))
            LHXERR(I) = LHXERR(I)*SQRT(RNWGT)
            LHXSCT(I) = LHXSCT(I)*1.0D3
            LHXERR(I) = LHXERR(I)*1.0D3
            LHXMAX(I) = LHXMAX(I)*1.0D3
          ENDDO
C--FOR THE SECOND WEIGHT OPTION THIS WAS AN INPUT
        ELSEIF(ABS(IDWTUP).EQ.2) THEN
          DO I=1,NPRUP
            LHXMAX(I) = LHXMAX(I)*1.0D3
          ENDDO
        ENDIF
        IF(ABS(IDWTUP).LE.2) THEN
          AVWGT = ZERO
          ERWGT = ZERO
          DO I=1,NPRUP
            WRITE(6,15) LPRUP(I),LHXSCT(I),LHXERR(I),LHXMAX(I)*1.0D-3,
     &            LHNEVT(I)
            AVWGT = AVWGT+LHXSCT(I)
            ERWGT = ERWGT+LHXERR(I)**2
          ENDDO
          AVWGT = AVWGT*1.0D-3
          ERWGT = SQRT(ERWGT)*1.0D-3
        ELSE
          RNWGT=1./FLOAT(NWGTS)
          IF (NEGWTS) AVABW=ABWSUM*RNWGT
          AVWGT=WGTSUM*RNWGT
          SPWGT=SQRT(MAX(WSQSUM*RNWGT-AVWGT**2,ZERO))
          ERWGT=SPWGT*SQRT(RNWGT)
          IF (.NOT.NOWGT) WGTMAX=AVWGT
          IF (WGTMAX.EQ.ZERO) WGTMAX=ONE
        ENDIF
C--STANDARD HERWIG OPTION
      ELSE
        RNWGT=1./FLOAT(NWGTS)
        IF (NEGWTS) AVABW=ABWSUM*RNWGT
        AVWGT=WGTSUM*RNWGT
        SPWGT=SQRT(MAX(WSQSUM*RNWGT-AVWGT**2,ZERO))
        ERWGT=SPWGT*SQRT(RNWGT)
        IF (.NOT.NOWGT) WGTMAX=AVWGT
        IF (WGTMAX.EQ.ZERO) WGTMAX=ONE
      ENDIF
C--PRINT OUT THE INFO
      WRITE (6,1)
 1    FORMAT(/10X,'OUTPUT ON ELEMENTARY PROCESS'/)
      IF (NEGWTS) THEN
         WRITE (6,12) NEVHEP,NNEGEV,NWGTS,NNEGWT,AVWGT,SPWGT,
     &        AVABW,WBIGST,WGTMAX,IPROC,
     &        1000.*AVWGT,1000.*ERWGT,100.*AVWGT/WGTMAX
      ELSE
         WRITE (6,11) NEVHEP,NWGTS,AVWGT,SPWGT,WBIGST,WGTMAX,
     &        IPROC,
     &        1000.*AVWGT,1000.*ERWGT,100.*AVWGT/WGTMAX
      ENDIF
 11   FORMAT(1P,
     &     10X,'N.B. NEGATIVE WEIGHTS NOT ALLOWED'//
     &     10X,'NUMBER OF EVENTS   = ',I11/
     &     10X,'NUMBER OF WEIGHTS  = ',I11/
     &     10X,'MEAN VALUE OF WGT  =',E12.4/
     &     10X,'RMS SPREAD IN WGT  =',E12.4/
     &     10X,'ACTUAL MAX WEIGHT  =',E12.4/
     &     10X,'ASSUMED MAX WEIGHT =',E12.4//
     &     10X,'PROCESS CODE IPROC = ',I11/
     &     10X,'CROSS SECTION (PB) =',G12.4/
     &     10X,'ERROR IN C-S  (PB) =',G12.4/
     &     10X,'EFFICIENCY PERCENT =',G12.4)
 12   FORMAT(1P,
     &     10X,'N.B. NEGATIVE WEIGHTS ALLOWED'//
     &     10X,'NUMBER OF EVENTS   = ',I11/
     &     10X,'NEGATIVE  EVENTS   = ',I11/
     &     10X,'NUMBER OF WEIGHTS  = ',I11/
     &     10X,'NEGATIVE  WEIGHTS  = ',I11/
     &     10X,'MEAN VALUE OF WGT  =',E12.4/
     &     10X,'RMS SPREAD IN WGT  =',E12.4/
     &     10X,'MEAN ABS WEIGHT    =',E12.4/
     &     10X,'ACTUAL MAX ABS WGT =',E12.4/
     &     10X,'ASSUMED MAXABS WGT =',E12.4//
     &     10X,'PROCESS CODE IPROC = ',I11/
     &     10X,'CROSS SECTION (PB) =',G12.4/
     &     10X,'ERROR IN C-S  (PB) =',G12.4/
     &     10X,'EFFICIENCY PERCENT =',G12.4)
 13   FORMAT(/1P,10X,'OUTPUT ON LES HOUCHES EVENTS'/)
 14   FORMAT(/1P,5X,' PROC CODE',1X,' XSECT(pb)     ',1X,
     &     '  XERR(pb)  ',1X,'   Max wgt(nb)',1X,'No. of events'/)
 15   FORMAT(5X,I7,E15.5,1X,E15.5,1X,E15.5,2X,I7)
      END
