CDECK  ID>, HWUDKL.
*CMZ :-        -27/07/99  13.33.03  by  Mike Seymour
*-- Author :    Ian Knowles
C-----------------------------------------------------------------------
      SUBROUTINE HWUDKL(ID,PMOM,DISP)
C-----------------------------------------------------------------------
C     Given a real or virtual particle, flavour ID and 4-momentum PMOM,
C     returns DISP its distance travelled in mm.
C
C     Modified 16/01/01 by BRW to force particle on mass shell if
C     p^2-m^2 < 10^-10 GeV^2 (rounding errors)
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWRGEN,PMOM(4),DISP(4),PMOM2,SCALE,OFFSH
      INTEGER ID
      EXTERNAL HWRGEN
      PMOM2=(PMOM(4)+PMOM(3))*(PMOM(4)-PMOM(3))-PMOM(1)**2-PMOM(2)**2
      OFFSH=PMOM2-RMASS(ID)**2
      IF (OFFSH.LT.1D-10) OFFSH=ZERO
      SCALE=-GEV2MM*LOG(HWRGEN(0))/SQRT(OFFSH**2+(PMOM2/DKLTM(ID))**2)
      IF (ID.GT.197.AND.ID.LT.203) SCALE=SCALE*EXAG
      CALL HWVSCA(4,SCALE,PMOM,DISP)
      END
