C
C
      SUBROUTINE AMPFIT(M,N,F,X,IFLAG)
C*********************************************************************
C
C     calculate deviations ( called by MINSQ, CERNLIB )
C
C     input parameter: M      number of function values in field F
C                      N      dimension of argument vector
C                      F      field of function values
C                      X      field of argument values
C                      IFLAG  flag to indicate status of MINSQ
C                             ( see CERNLIB D507 )
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      DIMENSION F(M),X(N)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
C
      PARAMETER ( MAXPRO = 16 )
      COMPLEX*16      SIGP,SIGR,SIGHD,SIGHR,SIGT1,SIGT2,SIGL,SIGDP,
     &                SIGD1,SIGD2,DSIGH
      COMMON /SIGMAS/ SIGP,SIGR,SIGHD,SIGHR,SIGT1(2),SIGT2(2),SIGL,
     &                SIGDP(4),SIGD1(2),SIGD2(2),DSIGH(0:MAXPRO)
C
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
C
      PARAMETER (NECM=200,NPAR=30)
      PARAMETER (ZERO=0.D0,
     &           IZERO=0,
     &           IONE =1,
     &           ITWO =2,
     &          ITHREE=3,
     &           IFOUR=4)
      CHARACTER*6 HINT
      COMMON /FITMOD/ IFMOD,IFHARD
      COMMON /FITTYP/IFIT,NIST,ECMS(NECM),XTOT(NECM),XTOTE(NECM),
     &               XELA(NECM),XELAE(NECM),XINE(NECM),
     &               XINEE(NECM),XSDI(NECM),XSDIE(NECM),
     &               SLO(NECM),SLOE(NECM),XPRO(3,NECM),XPROE(3,NECM),
     &               XI(NPAR),XINC(NPAR),NFITP,HINT(NPAR),IFITF(NPAR)
      PARAMETER(MAXKK=20,MAXDS=20)
      COMMON /DSIGEL/ DSDT(MAXKK,3,MAXDS),DSIGI(3,MAXKK)
C
      DIMENSION DSIGMC(0:MAXPRO,NECM),XTA(6,MAXDS),SIGSDI(2)
C
      IF(IDEB(62).GE.10)
     &  WRITE(6,*) ' ************* call to AMPFIT *****************'
C
C***  update common blocks ( copy fit parameter )
      DO 100 I=1,NFITP
         XI(IFITF(I))=X(I)
 100  CONTINUE
      ALPOM  =      XI(1)
      ALPOMP =      XI(2)
      GP(1)  =      XI(3)
      GP(2)  =      XI(4)
      B0POM(1)  =   ABS(XI(5))
      B0POM(2)  =   ABS(XI(6))
      ALREG  =      XI(7)
      ALREGP =      XI(8)
      GR(1)  =      XI(9)
      B0REG(1) =    ABS(XI(10))
      GPPP   =      ABS(XI(11))
      B0PPP  =      ABS(XI(12))
      VDMFAC(1) =   ABS(XI(13))
      VDMFAC(2) =   ABS(XI(14))
      VDMFAC(3) =   ABS(XI(15))
      VDMFAC(4) =   ABS(XI(16))
      B0HAR  =      ABS(XI(17))
      AKFAC  =      XI(18)
      PHISUP(1) =   XI(19)
*     GR(2)     =   GP(2)/GP(1)*GR(1)
*     B0REG(2)  =   B0POM(2)/B0POM(1)*B0REG(1)
C  FMSR
*     PHISUP(2) =   PHISUP(1)*SQRT(GP(1)/GP(2))
      PHISUP(2) =   XI(20)
      RMASS1 =      XI(21)
      RMASS2 =      XI(22)
      GPPR   =      ABS(XI(23))
      B0PPR  =      ABS(XI(24))
C  scattering of identical particles
      IF(ABS(IFPAP(1)).EQ.ABS(IFPAP(2))) THEN
        B0POM(2)  = B0POM(1)
        B0REG(2)  = B0REG(1)
        GP(2)     = GP(1)
        GR(2)     = GR(1)
        PHISUP(2) = PHISUP(1)
        RMASS2    = RMASS1
      ENDIF
      IF(IPAMDL(9).EQ.2) B0HAR = B0POM(1)+B0POM(2)
C  VDM couplings
      RHOM2 = 0.59D0
      IF(IFPAP(1).EQ.22) THEN
        VDMQ2F(1) = RHOM2/(RHOM2+PVIRT(1)**2)*VDMFAC(1)
        VDMQ2F(2) = RMASS1**2/(RMASS1**2+PVIRT(1)**2)*VDMFAC(2)
      ELSE
        VDMQ2F(1) = VDMFAC(1)
        VDMQ2F(2) = VDMFAC(2)
      ENDIF
      IF(IFPAP(2).EQ.22) THEN
        VDMQ2F(3) = RHOM2/(RHOM2+PVIRT(2)**2)*VDMFAC(3)
        VDMQ2F(4) = RMASS2**2/(RMASS2**2+PVIRT(2)**2)*VDMFAC(4)
      ELSE
        VDMQ2F(3) = VDMFAC(3)
        VDMQ2F(4) = VDMFAC(4)
      ENDIF
C
      IF(IDEB(62).GE.5) THEN
        WRITE(6,'(1X,A)') 'AMPFIT:DEBUG:PARAMETER SET:'
        WRITE(6,'(2(A,F7.3),2(A,2F9.3))')
     &    '  ALPOM:',ALPOM,' ALPOMP:',ALPOMP,' GP:',GP,'  B0POM:',
     &    B0POM
        WRITE(6,'(2(A,F7.3),2(A,2F9.3))')
     &    '  ALREG:',ALREG,' ALREGP:',ALREGP,' GR:',GR,'  B0REG:',
     &    B0REG
        WRITE(6,'(2(A,F8.3))')
     &    '  GPPP :',GPPP,' B0PPP:',B0PPP,' GPPR :',GPPR,' B0PPR:',B0PPR
        WRITE(6,'(A,4F8.5)') '  VDMFAC:',VDMFAC
        WRITE(6,'(A,4F8.5)') '  VDMQ2F:',VDMQ2F
        WRITE(6,'(5X,A,F8.3)')  '   B0HAR:',B0HAR
        WRITE(6,'(5X,A,F8.3)')  '   AKFAC:',AKFAC
        WRITE(6,'(5X,A,2F8.3)')  '  PHISUP:',PHISUP
        WRITE(6,'(5X,A,3F8.3)') '   RMASS:',RMASS1,RMASS2,VAR
      ENDIF
C
C  loop over all energies
      K=1
      DO 110 I=1,NIST
         ECM = ECMS(I)
         IF(IFMOD.EQ.0) THEN
C  calculate hard input cross section each time
           IFHARD = -1
           CALL POXSEC(1,ECMS(I))
         ELSE IF(IFMOD.EQ.IONE) THEN
C  calculate hard input cross section first time only
           IF(IFLAG.EQ.1) THEN
             IFHARD = 0
             CALL POXSEC(1,ECMS(I))
             DO 105 II=0,MAXPRO
               DSIGMC(II,I)=DSIGH(II)
 105         CONTINUE
           ELSE
             DO 120 II=0,MAXPRO
               DSIGH(II)=DSIGMC(II,I)
 120         CONTINUE
             IFHARD = 1
             CALL POXSEC(1,ECMS(I))
           ENDIF
         ELSE IF(IFMOD.EQ.2) THEN
           CALL TESTF
         ELSE
           WRITE(6,*) ' FCN: ERROR: unsupported fit mode ',IFMOD
           STOP
         ENDIF
         SIGSDI(1) = SIGLSD(1)+SIGHSD(1)
         SIGSDI(2) = SIGLSD(2)+SIGHSD(2)
C  total cross section
         IF(XTOT(I).GT.ZERO) THEN
           F(K)=(SIGTOT-XTOT(I))/XTOTE(I)
           K=K+1
         ENDIF
C  total elastic cross section
         IF(XELA(I).GT.ZERO) THEN
           F(K)=(SIGELA-XELA(I))/XELAE(I)
           K=K+1
         ENDIF
C  inelastic cross section
         IF(XINE(I).GT.ZERO) THEN
           F(K)=(SIGINE-XINE(I))/XINEE(I)
           K=K+1
         ENDIF
C  single diffractive cross section
         IF(XSDI(I).GT.ZERO) THEN
           F(K)=(SIGSDI(1)+SIGSDI(2)-XSDI(I))/XSDIE(I)
           K=K+1
         ENDIF
C  slope parameter
         IF(SLO(I).GT.ZERO) THEN
           F(K)=(SLOEL-SLO(I))/SLOE(I)
           K=K+1
         ENDIF
C  vector meson production cross section
         DO 10 KK=1,3
           IF(XPRO(KK,I).GT.ZERO) THEN
             F(K)=(SIGVM(KK,0)-XPRO(KK,I))/XPROE(KK,I)
             K=K+1
           ENDIF
 10      CONTINUE
C
C  last iteration / debug output: write out all results
       IF((IFLAG.EQ.3).OR.(IFLAG.EQ.1).OR.(IDEB(62).GE.20)) THEN
         II = 10
         IF(IDEB(62).GE.20) II = 6
         WRITE(II,*) ' --------------------------------------------'
         WRITE(II,'(1X,A,F10.2)') 'AMPFIT:DEBUG:ENERGY',ECMS(I)
C  total cross section
         IF(XTOT(I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'SIGTOT',XTOT(I),XTOTE(I),SIGTOT,
     &          ((XTOT(I)-SIGTOT)/XTOTE(I))**2
         ENDIF
C  total elastic cross section
         IF(XELA(I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'SIGEL ',XELA(I),XELAE(I),SIGELA,
     &          ((XELA(I)-SIGELA)/XELAE(I))**2
         ENDIF
C  inelastic cross section
         IF(XINE(I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'SIGIN ',XINE(I),XINEE(I),SIGTOT-SIGELA,
     &          ((XINE(I)-SIGTOT+SIGELA)/XINEE(I))**2
         ENDIF
C  single diffractive cross section
         IF(XSDI(I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,5E12.4)')
     &          'SIGSD ',XSDI(I),XSDIE(I),SIGSDI,
     &          ((XSDI(I)-(SIGSDI(1)+SIGSDI(2)))/XSDIE(I))**2
         ENDIF
C  nuclear slope
         IF(SLO(I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'SLOPE ',SLO(I),SLOE(I),SLOEL,
     &          ((SLO(I)-SLOEL)/SLOE(I))**2
         ENDIF
C  RHO production cross section
         IF(XPRO(1,I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'RHOPRO',XPRO(1,I),XPROE(1,I),SIGVM(1,0),
     &          ((XPRO(1,I)-SIGVM(1,0))/XPROE(1,I))**2
         ENDIF
C  OMEGA production cross section
         IF(XPRO(2,I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'OMEPRO',XPRO(2,I),XPROE(2,I),SIGVM(2,0),
     &          ((XPRO(2,I)-SIGVM(2,0))/XPROE(2,I))**2
         ENDIF
C  PHI production cross section
         IF(XPRO(3,I).GT.0.0) THEN
           WRITE(II,'(1X,A,2X,4E12.4)')
     &          'PHIPRO',XPRO(3,I),XPROE(3,I),SIGVM(3,0),
     &          ((XPRO(3,I)-SIGVM(3,0))/XPROE(3,I))**2
         ENDIF
       ENDIF
 110  CONTINUE
C  differential elastic cross section
      DO 130 I=1,MAXKK
         IF(INT(DSIGI(2,I)).GT.IZERO) THEN
           DO 140 KK=1,INT(DSIGI(2,I))
             XTA(1,KK)=DSDT(I,1,KK)
 140       CONTINUE
           CALL DSIGDT(DSIGI(1,I),XTA,INT(DSIGI(2,I)))
           DO 150 KK=1,INT(DSIGI(2,I))
             F(K+KK-1)=
     &       (XTA(INT(DSIGI(3,I))+1,KK)-DSDT(I,2,KK))/DSDT(I,3,KK)
 150       CONTINUE
C  last iteration: write out all results
           IF((IFLAG.EQ.3).OR.(IFLAG.EQ.1)) THEN
             WRITE(10,*)
     &              ' --------------------------------------------'
             IF(INT(DSIGI(3,I)).EQ.IONE) THEN
               WRITE(10,'(1X,A)') 'PHOTON PROTON ELASTIC SCATTERING'
             ELSE IF(INT(DSIGI(3,I)).EQ.ITWO) THEN
               WRITE(10,'(1X,A)') 'DIFFRACTIVE RHO PRODUCTION'
             ELSE IF(INT(DSIGI(3,I)).EQ.ITHREE) THEN
               WRITE(10,'(1X,A)') 'DIFFRACTIVE OMEGA PRODUCTION'
             ELSE IF(INT(DSIGI(3,I)).EQ.IFOUR) THEN
               WRITE(10,'(1X,A)') 'DIFFRACTIVE PHI PRODUCTION'
             ELSE
               WRITE(10,'(1X,A)') 'DATINP:ERROR: unknown particle'
               STOP
             ENDIF
             WRITE(10,'(1X,A,E12.3,A,E12.3)')
     &            'DSIG/DT  ',DSIGI(1,I),'   ',DSIGI(2,I)
             DO 155 KK=1,INT(DSIGI(2,I))
               WRITE(10,'(2X,3E12.3,2X,2E12.3)')
     &            DSDT(I,1,KK),DSDT(I,2,KK),DSDT(I,3,KK),
     &            XTA(INT(DSIGI(3,I))+1,KK),
     &            ((XTA(INT(DSIGI(3,I))+1,KK)-DSDT(I,2,KK))
     &             /DSDT(I,3,KK))**2
 155         CONTINUE
           ENDIF
           K=K+INT(DSIGI(2,I))
         ENDIF
 130  CONTINUE
      K=K-1
C  cross check
      IF(K.NE.IFIT) THEN
        WRITE(6,*) ' AMPFIT: ERROR: fit items do not conform with IFIT'
        WRITE(6,*) ' Items: ',K,'    IFIT: ',IFIT
        STOP
      ENDIF
C  debug output
      IF(IDEB(62).GE.5) THEN
        XCHI = 0.D0
        DO 115 KK=1,K
          XCHI = XCHI+F(KK)**2
 115    CONTINUE
        WRITE(6,'(1X,A,E12.4)') 'AMPFIT:DEBUG:CHI**2',XCHI
        IF(IDEB(62).GE.10)
     &    WRITE(6,*) ' ************** end of AMPFIT *****************'
      ENDIF
      RETURN
      END
