C
C
      SUBROUTINE DATINP(NOUT,IFLAG)
C*********************************************************************
C
C     print out all important data values
C
C     input parameter: NOUT   number of output unit
C                      IFLAG  flag to select output of energy table
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
C
      PARAMETER (NECM=200,NPAR=30)
      CHARACTER*6 HINT
      COMMON /FITTYP/IFIT,NIST,ECMS(NECM),XTOT(NECM),XTOTE(NECM),
     &               XELA(NECM),XELAE(NECM),XINE(NECM),
     &               XINEE(NECM),XSDI(NECM),XSDIE(NECM),
     &               SLO(NECM),SLOE(NECM),XPRO(3,NECM),XPROE(3,NECM),
     &               XI(NPAR),XINC(NPAR),NFITP,HINT(NPAR),IFITF(NPAR)
      PARAMETER(MAXKK=20,MAXDS=20)
      COMMON /DSIGEL/ DSDT(MAXKK,3,MAXDS),DSIGI(3,MAXKK)
      PARAMETER(IZERO =0,
     &          IONE  =1,
     &          ITWO  =2,
     &          ITHREE=3,
     &          IFOUR =4)
C
C  write out initialization
      WRITE(NOUT,*)
     &  ' -------------------------------------------------'
      IF(IFLAG.EQ.1) THEN
        WRITE(NOUT,*) ' Energy data entries :',NIST
        WRITE(NOUT,*) ' Total fit data items:',IFIT
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV ---- SIGMAtot (mub) -------- Error (mub) '
        DO 10 I=1,NIST
          IF(XTOT(I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XTOT(I),' +- ',XTOTE(I)
          ENDIF
 10     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV ---- SIGMAela (mub) --------- Error (mub) '
        DO 11 I=1,NIST
          IF(XELA(I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XELA(I),' +- ',XELAE(I)
          ENDIF
 11     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV --- SIGMAinela (mub) --------- Error (mub) '
        DO 12 I=1,NIST
          IF(XINE(I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XINE(I),' +- ',XINEE(I)
          ENDIF
 12     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV --- SIGMAsdiff (mub) --------- Error (mub) '
        DO 13 I=1,NIST
          IF(XSDI(I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XSDI(I),' +- ',XSDIE(I)
          ENDIF
 13     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV --- SLOPE (GeV**-2) ---------- Error (GeV**-2)'
        DO 16 I=1,NIST
          IF(SLO(I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),SLO(I),' +- ',SLOE(I)
          ENDIF
 16     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV --- SIGMA (RHO production) (mub) --- Error ---'
        DO 17 I=1,NIST
          IF(XPRO(1,I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XPRO(1,I),' +- ',XPROE(1,I)
          ENDIF
 17     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV -- SIGMA (OMEGA production) (mub) -- Error ---'
        DO 18 I=1,NIST
          IF(XPRO(2,I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XPRO(2,I),' +- ',XPROE(2,I)
          ENDIF
 18     CONTINUE
        WRITE(NOUT,*)
     &  ' --- Ecms/GeV --- SIGMA (PHI production) (mub) --- Error ---'
        DO 19 I=1,NIST
          IF(XPRO(3,I).GT.0.0) THEN
            WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            ECMS(I),XPRO(3,I),' +- ',XPROE(3,I)
          ENDIF
 19     CONTINUE
        DO 20 KK=1,MAXKK
          IF(INT(DSIGI(2,KK)).GT.IZERO) THEN
            IF(INT(DSIGI(3,KK)).EQ.IONE) THEN
              WRITE(NOUT,'(1X,A)') 'PHOTON PROTON ELASTIC SCATTERING'
            ELSE IF(INT(DSIGI(3,KK)).EQ.ITWO) THEN
              WRITE(NOUT,'(1X,A)') 'DIFFRACTIVE RHO PRODUCTION'
            ELSE IF(INT(DSIGI(3,KK)).EQ.ITHREE) THEN
              WRITE(NOUT,'(1X,A)') 'DIFFRACTIVE OMEGA PRODUCTION'
            ELSE IF(INT(DSIGI(3,KK)).EQ.IFOUR) THEN
              WRITE(NOUT,'(1X,A)') 'DIFFRACTIVE PHI PRODUCTION'
            ELSE
              WRITE(NOUT,'(1X,A)') 'DATINP:ERROR: unknown particle'
              STOP
            ENDIF
            WRITE(NOUT,'(3X,A,E15.3)') ' DSIG/DT  energy (GeV) ',
     &            DSIGI(1,KK)
            WRITE(NOUT,*)
     &  ' --- T (GeV**2)-- DSIGDT (mub/GeV**2) --- Error (mub/GeV**-2)'
            DO 21 II=1,INT(DSIGI(2,KK))
              WRITE(NOUT,'(2X,2E15.3,A,E15.3)')
     &            DSDT(KK,1,II),DSDT(KK,2,II),' +- ',DSDT(KK,3,II)
 21         CONTINUE
          ENDIF
 20     CONTINUE
      ENDIF
C
      WRITE(NOUT,'(1X,A)') 'DATINP:DEBUG:PARAMETER SET:'
      WRITE(NOUT,'(2(A,F7.3),2(A,2F9.3))')
     &  '  ALPOM:',ALPOM,' ALPOMP:',ALPOMP,' GP:',GP,' B0POM:',
     &  B0POM
      WRITE(NOUT,'(2(A,F7.3),2(A,2F9.3))')
     &  '  ALREG:',ALREG,' ALREGP:',ALREGP,' GR:',GR,' B0REG:',
     &  B0REG
      WRITE(NOUT,'(4(A,F8.3))')
     &  '  GPPP :',GPPP,' B0PPP:',B0PPP,' GPPR :',GPPR,' B0PPR:',B0PPR
      WRITE(NOUT,'(5X,A,4F8.5)') '  VDMFAC:',VDMFAC(1),VDMFAC(2),
     &                                         VDMFAC(3),VDMFAC(4)
      WRITE(NOUT,'(5X,A,F8.3)')  '   B0HAR:',B0HAR
      WRITE(NOUT,'(5X,A,F8.3)')  '   AKFAC:',AKFAC
      WRITE(NOUT,'(5X,A,2F8.3)')  '  PHISUP:',PHISUP
      WRITE(NOUT,'(5X,A,3F8.3)') '   RMASS:',RMASS1,RMASS2,VAR
C
      IF(IFLAG.EQ.1) THEN
        WRITE(NOUT,'(A)') 'FIT PARAMETERS: '
        DO 15 I=1,NFITP
           WRITE(NOUT,*) '  IFITF(',I,')=',IFITF(I),
     &                  '   --> ',HINT(IFITF(I))
 15     CONTINUE
        DO 25 I=1,NFITP
          WRITE(NOUT,*)
     &    '  XI(',IFITF(I),') = ',XI(IFITF(I)),
     &    '  XINC(',IFITF(I),') = ',XINC(IFITF(I))
 25     CONTINUE
      ENDIF
      WRITE(NOUT,*)
     &  ' -------------------------------------------------'
C
      END
