C
C
      SUBROUTINE HADSP3(IFLB,XS1,XMAX,XSOFT1,IREJ)
C***********************************************************************
C
C     split hadron momentum XMAX into diquark & quark pair
C     using lower cut-off: AS
C
C     input:   IFLB    compressed particle code of particle to split
C              XS1     sum of x values already selected
C              XMAX    maximal x possible
C
C     output:  XS1     new sum of x values
C              XSOFT1  field of selected x values
C
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           DEPS   =  1.D-8)
C
      DIMENSION XSOFT1(50),XSOFT2(50)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
      DIMENSION XPOT1(3),XPOT2(3)
C
C  model exponents
      DATA PVMES1 /-0.5D0/
      DATA PVMES2 /-0.5D0/
      DATA PSMES  /-0.99D0/
      DATA PVBAR1 / 1.5D0/
      DATA PVBAR2 /-0.5D0/
      DATA PSBAR  /-0.99D0/
C
      IREJ = 0
C
C  determine exponents
C  particle 1
C
C  mesonic particle
      IF(IBAR(IFLB).EQ.0) THEN
        XPOT1(1) = PVMES1
        XPOT1(2) = PVMES2
        XPOT1(3) = PSMES
C  baryonic particle
      ELSE
        XPOT1(1) = PVBAR1
        XPOT1(2) = PVBAR2
        XPOT1(3) = PSBAR
      ENDIF
C  particle 2
C  mesonic particle
      XPOT2(1) = PVMES1
      XPOT2(2) = PVMES2
      XPOT2(3) = PSMES
C
      XDUM1 = 0.01D0
      XDUM2 = 0.99D0
*     CALL SELSXR(3,XPOT1,XPOT2,XS1,XDUM1,XMAX,XDUM2,
*    &            XSOFT1,XSOFT2,IREJ)
      CALL SELSXS(3,3,XPOT1,XPOT2,XS1,XDUM1,XMAX,XDUM2,
     &            XSOFT1,XSOFT2,IREJ)
C  rejection?
      IF(IREJ.NE.0) THEN
        IF(IDEB(74).GE.3) WRITE(6,'(1X,A,I6,2E12.4)')
     &    'HADSP3:WARNING:REJECTION (IFLB,XS1,XMAX)',IFLB,XS1,XMAX
        IFAIL(15) = IFAIL(15)+1
        IREJ = 1
        RETURN
      ENDIF
C  debug output
      IF(IDEB(74).GE.10) THEN
        WRITE(6,'(1X,A,I6,2E12.4)')
     &    'HADSP3:DEBUG:IFLB,XS1,XMAX',IFLB,XS1,XMAX
        DO 100 I=1,3
          WRITE(6,'(10X,I4,2E12.4)') I,XSOFT1(I),XSOFT2(I)
 100    CONTINUE
      ENDIF
      END
