C
C
      SUBROUTINE MOMENT(IHIS)
C**********************************************************************
C
C     calculated normalized moments of distribution binned in
C                                      histogram IHIS
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NHIS=200, NDIM=51)
      COMMON /HISTOS/ XLIMIT(3,NHIS),ISWI(NHIS),ENTRY(NHIS),
     &                HIST(4,NHIS,NDIM),EVENT(NHIS),OVERF(NHIS),
     &                UNDERF(NHIS),IBINS(NHIS),
     &                IHMIN(NHIS),IHMAX(NHIS),IHISL
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
      DIMENSION YM(5),C(5)
C
      DO 50 I=1,5
        YM(I) = ZERO
 50   CONTINUE
C
      SUM = ZERO
      DO 100 K=1,NDIM
        SUM = SUM + HIST(2,IHIS,K)
 100  CONTINUE
C
C  absolute moments
      DO 200 K=1,NDIM
        X = (DBLE(K-1)+OHALF)*XLIMIT(3,IHIS)+XLIMIT(1,IHIS)
        XX = X
        YM(1) = YM(1) + HIST(2,IHIS,K)*XX
        XX = XX*X
        YM(2) = YM(2) + HIST(2,IHIS,K)*XX
        XX = XX*X
        YM(3) = YM(3) + HIST(2,IHIS,K)*XX
        XX = XX*X
        YM(4) = YM(4) + HIST(2,IHIS,K)*XX
        XX = XX*X
        YM(5) = YM(5) + HIST(2,IHIS,K)*XX
 200  CONTINUE
C
C  normalized moments
      DO 300 K=1,5
        YM(K)=YM(K)/SUM
        C(K) = YM(K)/YM(1)**K
 300  CONTINUE
C
C  write results
      WRITE(6,'(/1X,A,/1X,A)') 'ABSOLUTE AND SCALED MOMENTS',
     &                         '==========================='
      DO 400 K=1,5
        WRITE(6,'(5X,A,I2,3X,A,E12.3,A,E12.3)')
     &    ' RANK ',K,' ABSOLUTE ',YM(K),'          NORMALIZED ',C(K)
 400  CONTINUE
C
      END
