C
C
      SUBROUTINE OUTHIS(I,ILOG,HEADER,FAC,INORM)
C**********************************************************************
C
C     write out histogram
C
C     input: COMMON HISTOS
C            I              histogram number
C            ILOG           0 linear axis
C                           1 log y axis
C                           2 log x axis
C                           3 log x and y axis
C            HEADER         header string
C            FAC            factor to change normalization
C            INORM          0 normalization per event and bin width
C                           1 normalization per entry and bin width
C                           2 normalization per bin entry
C                           3 normalization per event and bin width**2
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NHIS=200, NDIM=51)
      COMMON /HISTOS/ XLIMIT(3,NHIS),ISWI(NHIS),ENTRY(NHIS),
     &                HIST(4,NHIS,NDIM),EVENT(NHIS),OVERF(NHIS),
     &                UNDERF(NHIS),IBINS(NHIS),
     &                IHMIN(NHIS),IHMAX(NHIS),IHISL
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  1.D-5,
     &           TINY   =  1.D-8)
C
      DIMENSION HI(NDIM)
C
      PARAMETER(NDIM2 = 2*NDIM)
      DIMENSION XX(NDIM2),YY(NDIM2)
      CHARACTER*72 HEADER
C
      AVERY = ZERO
      AVERX = ZERO
      AVERX2 = ZERO
      AVERY2 = ZERO
      SUM = ZERO
C
      IF((I.LT.1).OR.(I.GT.NHIS)) THEN
        WRITE(6,'(/1X,A,I6)') 'OUTHIS:ERROR: HISTOGRAM OUT OF RANGE ',I
        RETURN
      ELSE IF(ISWI(I).EQ.0) THEN
        WRITE(6,'(/1X,A,I6)')
     &    'OUTHIS:ERROR: HISTOGRAM NOT INITIALIZED ',I
        RETURN
      ENDIF
C
      WRITE(6,'(//1X,A,/,1X,70A1)') HEADER,('=',II=1,70)
      IF(ENTRY(I).LT.0.5D0) THEN
        WRITE(6,'(1X,A,2F10.0)')
     &    'OUTHIS:WARNING: NO ENTRIES, UNDERFLOWS, OVERFLOWS',
     &    UNDERF(I),OVERF(I)
        RETURN
      ENDIF
C
      IF(ILOG.GE.2) THEN
        DO 221 K=1,IBINS(I)+1
          HIST(1,I,K) = EXP(HIST(1,I,K))
 221    CONTINUE
        WRITE(6,'(5X,A)') '(LOGARITHMIC X AXIS ASSUMED)'
      ENDIF
C
      DO 222 K=1,IBINS(I)
        IF(INORM.EQ.3) THEN
          HI(K) = HIST(2,I,K)/ENTRY(I)/
     &              (HIST(1,I,K+1)**2-HIST(1,I,K)**2)*FAC
        ELSE
          HI(K) = HIST(2,I,K)/ENTRY(I)/
     &              (HIST(1,I,K+1)-HIST(1,I,K))*FAC
        ENDIF
        AVERY = AVERY + HI(K)
        AVERY2 = AVERY2 + HI(K)**2
        SUM = SUM + HI(K)
 222  CONTINUE
C
      IF(ABS(SUM).LT.EPS) SUM = ONE
C
      DO 223 K=1,IBINS(I)
        X = (HIST(1,I,K)+HIST(1,I,K+1))/TWO
        AVERX = AVERX + HI(K)*X/SUM
        AVERX2 = AVERX2 + HI(K)*X**2/SUM
 223  CONTINUE
C
      AVERX2 =  AVERX2-AVERX**2
      AVERY  = AVERY/DBLE(IBINS(I))
      AVERY2 = AVERY2/DBLE(IBINS(I))-AVERY**2
      FNORM  = MAX(EVENT(I),ONE)
C
      WRITE(6,'(5X,3(A,F10.0))') 'ENTRIES ',ENTRY(I),
     &  '      UNDERFLOWS ',UNDERF(I),
     &  '      OVERFLOWS ',OVERF(I)
      WRITE(6,'(5X,A,F10.0)')   'EVENTS               ',EVENT(I)
      WRITE(6,'(5X,A,1P2E12.4)') 'MEAN VALUE / VARIANCE Y (event) ',
     &  AVERY*ENTRY(I)/FNORM,AVERY2*ENTRY(I)/FNORM
      WRITE(6,'(5X,A,1P2E12.4)') 'MEAN VALUE / VARIANCE Y (entry) ',
     &  AVERY,AVERY2
      WRITE(6,'(5X,A,1P2E12.4)') 'MEAN VALUE / VARIANCE X         ',
     &  AVERX,AVERX2
      WRITE(6,'(5X,A,1PE12.4)') 'SCALING FACTOR       ',FAC
      IF(ENTRY(I).LT.0.5D0) RETURN
C
      IF(INORM.EQ.3)
     &  WRITE(6,'(5X,A)') '(VALUES DIVIDED BY SQUARED BIN WIDTH)'
C
      WRITE(6,'(1X,50A)') ('=',II=1,50)
      WRITE(6,'(2X,A)')
     &  'NORMALIZED TO ENTRIES, EVENTS, BIN AVERAGE, ENTRIES'
      DO 333 K=1,IBINS(I)
        X1 = HIST(1,I,K)
        X2 = HIST(1,I,K+1)
        WRITE(6,'(1X,1P5E12.4)') X1,HI(K),
     &    HI(K)*ENTRY(I)/FNORM,
     &    HI(K)*ENTRY(I)*(HIST(1,I,K+1)-HIST(1,I,K))
     &    /FAC/MAX(HIST(3,I,K),ONE),
     &    HIST(3,I,K)
        WRITE(6,'(1X,1P5E12.4)') X2,HI(K),
     &    HI(K)*ENTRY(I)/FNORM,
     &    HI(K)*ENTRY(I)*(HIST(1,I,K+1)-HIST(1,I,K))
     &    /FAC/MAX(HIST(3,I,K),ONE),
     &    HIST(3,I,K)
        II = 2*K
        XX(II-1) = X1
        XX(II)   = X2
        IF((INORM.EQ.0).OR.(INORM.EQ.3)) THEN
          YY(II-1) = HI(K)*ENTRY(I)/FNORM
          YY(II)   = YY(II-1)
        ELSE IF(INORM.EQ.1) THEN
          YY(II-1) = HI(K)
          YY(II)   = HI(K)
        ELSE IF(INORM.EQ.2) THEN
          YY(II-1) = HI(K)*ENTRY(I)*(HIST(1,I,K+1)-HIST(1,I,K))
     &      /FAC/MAX(HIST(3,I,K),ONE)
          YY(II)   = YY(II-1)
        ELSE
          WRITE(6,'(/,1X,A,I5)') 'OUTHIS:ERROR:UNSUPPORTED INORM',
     &      INORM
        ENDIF
 333  CONTINUE
      WRITE(6,'(/1X,A,A)') 'PREVIEW: ',HEADER
      IBIN2 = 2.*IBINS(I)
      IF(ILOG.EQ.0) THEN
        CALL QGRAPH(0,0,IBIN2,1,XX,YY,YY)
      ELSE IF(ILOG.EQ.1) THEN
        CALL QGRAPH(0,1,IBIN2,1,XX,YY,YY)
      ELSE IF(ILOG.EQ.2) THEN
        CALL QGRAPH(1,0,IBIN2,1,XX,YY,YY)
      ELSE IF(ILOG.EQ.3) THEN
        CALL QGRAPH(1,1,IBIN2,1,XX,YY,YY)
      ELSE
        WRITE(6,'(/1X,A,I3)') 'OUTHIS:ERROR:INVALID ILOG',ILOG
      ENDIF
C
      IF(ILOG.GE.2) THEN
        DO 224 K=1,IBINS(I)+1
          HIST(1,I,K) = LOG(HIST(1,I,K))
 224    CONTINUE
      ENDIF
C
      END
