C
C

      SUBROUTINE PODIMA(I,J,K,L,AM8,AM82A,AM82B,AM10,I8A,I8B)
C**********************************************************************
C
C     determine minimal masses corresponding to the input flavours
C     (diquark a-diquark chain system)
C
C     input: I,J,K,L   1,2,3,4 -->  u/d/s/c
C                      7,8,9,10     au/ad/as/ac
C                               (other flavours are not supported)
C
C     output: AM8      mass of two octett baryons
C             AM82A,B  mass of one octett and one decuplett baryon
C             AM10     mass of two decuplett baryon
C             I8A,I8B  BAMJET baryon index for AM8 mass configuration
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
      COMMON/INPDAT/IMPS(6,6),IMVE(6,6),IB08(6,21),IB10(6,21),
     *IA08(6,21),IA10(6,21),A1,B1,B2,B3,LT,LB,ISU,IYQ,BET,AS,B8,AME,DIQ
C
      IF(I.GT.6) THEN
C  antibaryon
        II = I -6
        JJ = J -6
        KK = K
        LL = L
        IABAR = 1
      ELSE
C  baryon
        II = I
        JJ = J
        KK = K -6
        LL = L -6
        IABAR = 0
      ENDIF
C
C  find index
      CALL INDEX2(II,JJ,INDA)
      CALL INDEX2(KK,LL,INDB)
C
C  find possible two particle configuration (insert q qbar system)
      AM8   = 1000.D0
      AM82A = 1000.D0
      AM82B = 1000.D0
      AM10  = 1000.D0
      DO 100 IQ=1,4
        IF(IABAR.EQ.1) THEN
C  antibaryon A
          K8A  = IA08(IQ,INDA)
          K10A = IA10(IQ,INDA)
          K8B  = IB08(IQ,INDB)
          K10B = IB10(IQ,INDB)
        ELSE
C  baryon A
          K8A  = IB08(IQ,INDA)
          K10A = IB10(IQ,INDA)
          K8B  = IA08(IQ,INDB)
          K10B = IA10(IQ,INDB)
        ENDIF
        IF(K8A.LE.0) K8A=K10A
        IF(K8B.LE.0) K8B=K10B
        IF(AM8.GT.AM(K8A)+AM(K8B)) THEN
          I8A = K8A
          I8B = K8B
          AM8 = AM(K8A)+AM(K8B)
        ENDIF
        AM82A = MIN(AM82A,AM(K8A)+AM(K10B))
        AM82B = MIN(AM82B,AM(K8B)+AM(K10A))
        AM10  = MIN(AM10,AM(K10A)+AM(K10B))
 100  CONTINUE
      END
