C
C
      SUBROUTINE POHKIN(IREJ)
C***********************************************************************
C
C     selection of kinematic variables
C     (resolved and direct processes)
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER ( MAXPRO = 16 , MLINE = 400 , MSCAHD = 50 )
      PARAMETER ( TINY= 1.D-30, ONE=1.D0 ,TINYP=1.D-14 )
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
C
      COMMON /KINLIM/ ETAMI(2,15),ETAMA(2,15),XXMI(2,15),XXMA(2,15)
C
      DIMENSION RM(-1:MAXPRO)
      DATA RM / 3.31D0, 0.0D0,
     &          7.60D0, 0.65D0, 4.00D0, 0.65D0, 0.89D0, 
     &          0.45D0, 0.89D0, 0.89D0, 0.0D0,  4.776D0, 
     &          0.615D0,4.776D0,0.615D0,1.0D0,  0.0D0, 
     &          1.0D0 /
C
      IREJ = 0
      M    = MSPR
C------------- resolved processes -----------
      IF     ( M.EQ.1 ) THEN
10      CALL POHX12
        V  =-0.5D0*W1/(W1+RNDM(X1)*W)
        U  =-1.D0-V
        R  = (1.D0+W)*2.25D0*(V*V*(3.D0-U*V-V/(U*U))-U)
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(1)*RNDM(X2) ) GOTO 10
        IF ( RNDM(V).LE.0.5D0 ) V = U
      ELSEIF ( M.EQ.2 .OR. M.EQ.4 ) THEN
20      CALL POHX12
        WL = LOG(W1)
        V  =-EXP(-0.6931472D0+RNDM(X1)*WL)
        U  =-1.D0-V
        R  = (U*U+V*V)*((16.D0/27.D0)/U-(4.D0/3.D0)*V)*(WL/W)*AXX
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(M)*RNDM(X2) ) GOTO 20
        IF ( RNDM(V).LE.0.5D0 ) V = U
      ELSEIF ( M.EQ.3 ) THEN
30      CALL POHX12
        V  =-0.5D0*W1/(W1+RNDM(X1)*W)
        U  =-1.D0-V
        R  = (1.D0+W)*(1.D0+U*U)*(1.D0-(4.D0/9.D0)*V*V/U)
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(3)*RNDM(X2) ) GOTO 30
      ELSEIF ( M.EQ.5 ) THEN
50      CALL POHX12
        V  =-0.5D0*AXX/(W1+2.D0*RNDM(X1)*W)
        U  =-1.D0-V
        R  = (4.D0/9.D0)*(1.D0+U*U+V*V*(U*U+V*V))-(8.D0/27.D0)*U*U*V
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(5)*RNDM(X2) ) GOTO 50
      ELSEIF ( M.EQ.6 ) THEN
60      CALL POHX12
        V  =-0.5D0*(1.D0+W)+RNDM(X1)*W
        U  =-1.D0-V
        R  = (4.D0/9.D0)*(U*U+V*V)*AXX
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(6)*RNDM(V) ) GOTO 60
      ELSEIF ( M.EQ.7 ) THEN
70      CALL POHX12
        V  =-0.5D0*W1/(W1+RNDM(X1)*W)
        U  =-1.D0-V
        R  = (1.D0+W)*((2.D0/9.D0)*(1.D0+U*U+(1.D0+V*V)*V*V/(U*U))
     &       -(4.D0/27.D0)*V/U)
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(7)*RNDM(X2) ) GOTO 70
        IF ( RNDM(V).LE.0.5D0 ) V = U
      ELSEIF ( M.EQ.8 ) THEN
80      CALL POHX12
        V  =-0.5D0*AXX/(W1+2.D0*RNDM(X1)*W)
        U  =-1.D0-V
        R  = (4.D0/9.D0)*(1.D0+U*U)
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(8)*RNDM(X2) ) GOTO 80
      ELSEIF ( M.EQ.-1 ) THEN
90      CALL POHX12
        WL = LOG(W1)
        V  =-EXP(-0.6931472D0+RNDM(X1)*WL)
        U  =-1.D0-V
        R  = (1.D0+V*V)*(V/(U*U)-(4.D0/9.D0))*(WL/W)*AXX
        IF(R*W.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R*W.LT.RM(-1)*RNDM(X2) ) GOTO 90
C------------- direct processes -----------
      ELSEIF ( M.EQ.10 ) THEN
100     CALL POHDX1
        WL = LOG(AXX/(1.D0+W)**2)
        V  =-(1.D0+W)/2.D0*EXP(RNDM(X1)*WL)
        U  =-1.D0-V
        R  = -(8.D0/3.D0)*(V*V+1.D0)*WL*AXX
        IF(R.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R.LT.RM(10)*RNDM(V) ) GOTO 100
        X2 = X1
        X1 = 1.D0
      ELSEIF ( M.EQ.11) THEN
110     CALL POHDX1
        WL = LOG(W1)
        U  =-EXP(-0.6931472D0+RNDM(X1)*WL)
        V  =-1.D0-U
        R  = (U*U+V*V)/V*WL*AXX
        IF(R.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R.LT.RM(11)*RNDM(X2) ) GOTO 110
        IF ( RNDM(V).LE.0.5D0 ) V = U
        X2 = X1
        X1 = 1.D0
      ELSEIF ( M.EQ.12 ) THEN
120     CALL POHDX1
        WL = LOG(AXX/(1.D0+W)**2)
        U  =-(1.D0+W)/2.D0*EXP(RNDM(X1)*WL)
        V  =-1.D0-U
        R  = -(8.D0/3.D0)*(U*U+1.D0)*WL*AXX
        IF(R.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R.LT.RM(12)*RNDM(X2) ) GOTO 120
      ELSEIF ( M.EQ.13) THEN
130     CALL POHDX1
        WL = LOG(W1)
        V  =-EXP(-0.6931472D0+RNDM(X1)*WL)
        U  =-1.D0-V
        R  = (U*U+V*V)/U*WL*AXX
        IF(R.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R.LT.RM(13)*RNDM(X2) ) GOTO 130
        IF ( RNDM(V).LE.0.5D0 ) V = U
C------------- double direct process -----------
      ELSEIF ((M.EQ.14).OR.(M.EQ.16)) THEN
        X1 = 1.D0
        X2 = 1.D0
        AXX= AH
        W  = SQRT(MAX(TINY,ONE-AXX))
        W1 = AXX/(1.D0+W)
        WL = LOG(W1)
 140    V  =-EXP(-0.6931472D0+RNDM(X1)*WL)
        U  =-1.D0-V
        R  = -(U*U+V*V)/U
        IF(R.GT.RM(M)) WRITE(6,'(1X,A,I3)') 'POHKIN:WEIGHT ERROR',M
        IF ( R.LT.RM(14)*RNDM(X2) ) GOTO 140
        IF ( RNDM(V).LE.0.5D0 ) V = U
C---------------------------------------------
      ELSE
        WRITE(6,'(/1X,A,I3)')
     &    'POHKIN:ERROR:UNSUPPORTED PROCESS (MSPR)',MSPR
        CALL POABRT
      ENDIF
C
      V    = MAX(MIN(V,-TINYP ),-1.D0+TINYP)
      U    = -1.D0-V
      U    = MAX(MIN(U,-TINYP ),-1.D0+TINYP)
      PT   = SQRT(U*V*X1*X2)*ECMP
      ETAC = 0.5D0*LOG((U*X1)/(V*X2))
      ETAD = 0.5D0*LOG((V*X1)/(U*X2))
C
      MM = M
      IF(M.EQ.-1) MM = 3
      ETAMI(1,MM) = MIN(ETAMI(1,MM),ETAC)
      ETAMA(1,MM) = MAX(ETAMA(1,MM),ETAC)
      ETAMI(2,MM) = MIN(ETAMI(2,MM),ETAD)
      ETAMA(2,MM) = MAX(ETAMA(2,MM),ETAD)
      XXMI(1,MM) = MIN(XXMI(1,MM),X1)
      XXMA(1,MM) = MAX(XXMA(1,MM),X1)
      XXMI(2,MM) = MIN(XXMI(2,MM),X2)
      XXMA(2,MM) = MAX(XXMA(2,MM),X2)
C
      IF(IDEB(81).GE.25) WRITE(6,'(1X,A,/5X,6E12.3)')
     &  'POHKIN:DEBUG:V,PT,ETAC,ETAD,X1,X2',V,PT,ETAC,ETAD,X1,X2
      END
