C
C
      SUBROUTINE POHMCI(EMAXF)
C**********************************************************************
C
C     initialize MC sampling and calculate hard cross section
C
C     input:  EMAXF(4) maximal CMS energies to appear in
C                      interpolation table in reference to PTCUT(1..4)
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION EMAXF(4)
C
      PARAMETER (OHALF  = 0.5D0,
     &           ZERO   = 0.D0,
     &           DEPS   = 1.D-10,
     &           PLARGE = 1.D20 )
C
      COMMON /HACONS/ PI,PI2,PI4,GEV2MB
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C  global CM system
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
      COMMON /HAQQAP/ AQQAL,AQQALI,AQQALF,AQQPD,
     &                NQQAL,NQQALI,NQQALF,NQQPD
C
      PARAMETER ( MAXPRO = 16 )
      CHARACTER*18 PROC
      COMMON /PEPROC/ PROC(0:MAXPRO)
      PARAMETER ( MLINE = 400 , MSCAHD = 50 )
      COMMON /HAEVTR/ LINE,LIN,LREC1(MLINE),LREC2(MLINE),PREC(4,MLINE)
      PARAMETER ( MAXTAB = 20 )
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
C
      COMPLEX*16 DSIG
      DIMENSION DSIG(0:MAXPRO),DSPT(0:MAXPRO)
C
C  initialize COMMON /HAEVTR/
      LINE       = 0
      LIN        = 0
      DO 20 L = 1,MLINE
        LREC1(L) = 0
        LREC2(L) = 0
        DO 10 I=1,4
          PREC(I,L) = ZERO
 10     CONTINUE
 20   CONTINUE
C  initializaion for all pt cutoffs
      I0 = 4
      IF(ISWMDL(2).EQ.0) I0 = 1
      DO 110 I=I0,1,-1
C  skip unassigned PTCUT
        IF(PTCUT(I).LT.0.5D0) GOTO 90
C
        ELLOW = LOG(2.2*PTCUT(I))
        DELTA = (LOG(EMAXF(I))-ELLOW)/DBLE(ISTTAB-1)
        IF(DELTA.LE.ZERO) THEN
          DO 60 IE=1,ISTTAB
            ECMSH(I,IE) = EXP(ELLOW+DELTA*(IE-1))
            XSECTA(1,0,I,IE)  = PTCUT(I)
            XSECTA(1,-1,I,IE) = ZERO
            XSECTA(2,-1,I,IE) = ZERO
            DO 65 M=0,MAXPRO
              XSECTA(1,M,I,IE) = ZERO
              XSECTA(2,M,I,IE) = ZERO
              XSECTA(3,M,I,IE) = ZERO
              XSECTA(4,M,I,IE) = ZERO
  65        CONTINUE
 60       CONTINUE
          GOTO 90
        ENDIF
C  switch between external particles and Pomeron
        IF(I.EQ.1) THEN
          IDP1 = IFPAP(1)
          PV1  = PVIRT(1)
          IDP2 = IFPAP(2)
          PV2  = PVIRT(2)
        ELSE IF(I.EQ.2) THEN
          IDP1 = IFPAP(1)
          PV1  = PVIRT(1)
          IDP2 = 45
          PV2  = ZERO
        ELSE IF(I.EQ.3) THEN
          IDP1 = IFPAP(2)
          PV1  = PVIRT(2)
          IDP2 = 45
          PV2  = ZERO
        ELSE IF(I.EQ.4) THEN
          IDP1 = 45
          PV1  = ZERO
          IDP2 = 45
          PV2  = ZERO
        ENDIF
C  initialize PT scales
        IF((IDPDG1.EQ.22).OR.(IDPDG1.EQ.45)) THEN
          IF((IDPDG2.EQ.22).OR.(IDPDG2.EQ.45)) THEN
            FPS(I) = PARMDL(105)
            FPH(I) = PARMDL(106)
          ELSE
            FPS(I) = PARMDL(103)
            FPH(I) = PARMDL(104)
          ENDIF
        ELSE IF((IDPDG2.EQ.22).OR.(IDPDG2.EQ.45)) THEN
          FPS(I) = PARMDL(103)
          FPH(I) = PARMDL(104)
        ELSE
          FPS(I) = PARMDL(101)
          FPH(I) = PARMDL(102)
        ENDIF
C  initialize hard scattering
        CALL POHINI(I,IDP1,IDP2,PV1,PV2,6,IDEB(8))
C  initialization for several energies
        DO 100 IE=1,ISTTAB
          ECMSH(I,IE) = EXP(ELLOW+DELTA*(IE-1))
          CALL POHINT(I,ECMSH(I,IE),0,-2,0,0,1)
          IF(IDEB(8).GE.5) THEN
            WRITE(6,'(1X,A,2E10.3,2I7)')
     &        'POHMCI:DEBUG:CALC. OF (PT,ECM,ID1,ID2)',
     &        PTCUT(I),ECMSH(I,IE),IDPDG1,IDPDG2
          ENDIF
          CALL POHFAC(PTCUT(I),ECMSH(I,IE))
          CALL POHWGX(PTCUT(I),ECMSH(I,IE))
          CALL POHXTO(ECMSH(I,IE),PTCUT(I),PTCUT(I),DSIG,DSPT)
          IF(IDEB(8).GE.10) THEN
            WRITE(6,'(1X,A,/,1X,A)')
     &        'HARD CROSS SECTIONS SIGH(mb),DSIG/DPT(mb/GeV**2)',
     &        '================================================'
            DO 205 M=0,MAXPRO
              WRITE(6,'(10X,A,3E14.4)') PROC(M),DSIG(M),DSPT(M)
 205        CONTINUE
          ENDIF
          XSECTA(1,0,I,IE)  = PTCUT(I)
          XSECTA(1,-1,I,IE) = XSECT(1,-1)
          XSECTA(2,-1,I,IE) = XSECT(2,-1)
          DO 105 M=0,MAXPRO
            XSECTA(1,M,I,IE) = XSECT(1,M)
            XSECTA(2,M,I,IE) = XSECT(2,M)
            XSECTA(3,M,I,IE) = DREAL(DSIG(M))*MXSECT(0,M,I)
            XSECTA(4,M,I,IE) = DSPT(M)*MXSECT(0,M,I)
 105      CONTINUE
C  summed quantities
          XSECTA(3,9,I,IE) = ZERO
          XSECTA(4,9,I,IE) = ZERO
          DO 106 M=1,8
            IF(MXSECT(0,M,I).GT.0) THEN
              XSECTA(3,9,I,IE) = XSECTA(3,9,I,IE)+XSECTA(3,M,I,IE)
              XSECTA(4,9,I,IE) = XSECTA(4,9,I,IE)+XSECTA(4,M,I,IE)
            ENDIF
 106      CONTINUE
          XSECTA(3,15,I,IE) = ZERO
          XSECTA(4,15,I,IE) = ZERO
          DO 107 M=10,14
            IF(MXSECT(0,M,I).GT.0) THEN
              XSECTA(3,15,I,IE) = XSECTA(3,15,I,IE)+XSECTA(3,M,I,IE)
              XSECTA(4,15,I,IE) = XSECTA(4,15,I,IE)+XSECTA(4,M,I,IE)
            ENDIF
 107      CONTINUE
          XSECTA(3,0,I,IE) = XSECTA(3,9,I,IE)+XSECTA(3,15,I,IE)
          XSECTA(4,0,I,IE) = XSECTA(4,9,I,IE)+XSECTA(4,15,I,IE)
 100    CONTINUE
C  debug output of weights
        IF(IDEB(8).GE.5) THEN
          WRITE(6,'(/1X,A,5X,2I7,I3,F5.2,/1X,A)')
     &      'POHMCI:DEBUG:WEIGHTS,MAXIMA (ID1,ID2,IP,PTCUT)',
     &      IDPDG1,IDPDG2,I,PTCUT(I),
     &      '=============================================='
          DO 515 M=-1,MAXPRO
            IF((M.EQ.0).OR.(M.EQ.9).OR.(M.EQ.15)) GOTO 512
            WRITE(6,'(2X,A,I3,2I7)')
     &        'POHMCI:DEBUG:ECM XSECT(1-4) FOR PROCESS,ID1,ID2',
     &        M,IDPDG1,IDPDG2
            DO 510 K=1,ISTTAB
              WRITE(6,'(3X,5E12.4)') ECMSH(I,K),XSECTA(1,M,I,K),
     &        XSECTA(2,M,I,K),XSECTA(3,M,I,K),XSECTA(4,M,I,K)
 510        CONTINUE
 512        CONTINUE
 515      CONTINUE
        ENDIF
 90     CONTINUE
 110  CONTINUE
      END
