C
C
      SUBROUTINE POHREM(JM1,JM2,INDXH,IVAL,INDXS,IC1,IC2,IUSED,IREJ)
C*********************************************************************
C
C     get color structure for initial quark of hard scattering
C     and register hadron remnant
C
C     input:    JM1,2   index of mother particle in HEPEVS
C               INDXH   index of hard parton (hard pomeron number)
C                       positive for labels 1
C                       negative for labels 2
C               IVAL     1  hard valence parton
C                        0  hard sea parton connected by color flow with
C                           valence quarks
C                       -1  hard sea parton independent on valence quarks
C               INDXS   index of soft partons needed
C
C     output:   IC1,IC2 color label of initial parton
C               IUSED   number of soft X values used
C               IREJ
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
C
      PARAMETER ( MAXPRO = 16 , MLINE = 400 , MSCAHD = 50 )
      COMMON /ABRHRD/ XH1(50),XH2(50),IJHI1(50),IJHI2(50),
     &                IJHF1(50),IJHF2(50),PHARD1(4,50),PHARD2(4,50),IPTM
      COMMON /ABRSOF/ XS1(50),XS2(50),IJSI1(50),IJSI2(50),
     &                PSOFT1(4,50),PSOFT2(4,50)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
C
      IREJ = 0
      IF(INDXH.GT.0) THEN
        IJH = ICONV1(IJHI1(INDXH))
      ELSE
        IJH = ICONV1(IJHI2(-INDXH))
      ENDIF
C  direct process
      IUSED = 0
      IC1   = 0
      IC2   = 0
      IF((IJH.EQ.22).OR.(IJH.EQ.45)) RETURN
C
      IHP = 100*ABS(INDXH)
      IVSW = 1
      IF((IDHEP(JM1).EQ.22).OR.(IDHEP(JM1).EQ.45)) IVSW = 0
C
C  quark
        IF(IJH.NE.21) THEN
          IF(IVAL.EQ.1) THEN
C  valence quark engaged
            CALL PARTRE(JM1,IJH,IREM,IREJ)
            IF(IREJ.NE.0) THEN
              WRITE(6,'(/1X,A,2I6)')
     &          'POHREM:ERROR:INVALID VALENCE FLAVOURS JM,IFLA',JM1,IJH
              CALL POABRT
            ENDIF
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(((ABS(IREM).GT.6).AND.(IREM.GT.0))
     &         .OR.((ABS(IREM).LE.6).AND.(IREM.LT.0))) THEN
              I = ICA1
              ICA1 = ICB1
              ICB1 = I
            ENDIF
C  remainder of hadron
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = IREM
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = IREM
            ENDIF
C  registration
            CALL REGPAR(-1,IREM,0,JM1,JM2,P1,P2,P3,P4,
     &                    IHP,0,ICA1,IVSW,IPOS,1)
            CALL QUASTA(IREM,IDHEP(JM1),5)
            IUSED = 1
          ELSE IF(IVAL.EQ.0) THEN
C  sea quark and valence quarks engaged
            CALL VALFLA(JM1,IVFL1,IVFL2,PHEP(5,JM1))
            CALL QUASTA(IVFL1,IDHEP(JM1),1)
            CALL QUASTA(IVFL2,IDHEP(JM1),1)
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(RNDM(P1).LT.OHALF) THEN
              CALL SELCOL(ICB1,ICB2,ICB1,ICB2,ICC1,ICC2,2)
            ELSE
              CALL SELCOL(ICA1,ICA2,ICA1,ICA2,ICC1,ICC2,2)
            ENDIF
            IF(((ABS(IVFL1).GT.6).AND.(IVFL1.GT.0))
     &         .OR.((ABS(IVFL1).LE.6).AND.(IVFL1.LT.0))) THEN
              I = ICA1
              ICA1 = ICB1
              ICB1 = I
            ENDIF
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = IVFL1
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = IVFL1
            ENDIF
C  registration
            CALL REGPAR(-1,IVFL1,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICA1,IVSW,IPOS,1)
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+1)
              P2 = PSOFT1(2,INDXS+1)
              P3 = PSOFT1(3,INDXS+1)
              P4 = PSOFT1(4,INDXS+1)
              IJSI1(INDXS+1) = IVFL2
            ELSE
              P1 = PSOFT2(1,INDXS+1)
              P2 = PSOFT2(2,INDXS+1)
              P3 = PSOFT2(3,INDXS+1)
              P4 = PSOFT2(4,INDXS+1)
              IJSI2(INDXS+1) = IVFL2
            ENDIF
C  registration
            CALL REGPAR(-1,IVFL2,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICB1,IVSW,IPOS,1)
            IF(IJH.LT.0) THEN
              ICB1 = ICC2
              ICA1 = ICC1
            ELSE
              ICB1 = ICC1
              ICA1 = ICC2
            ENDIF
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+2)
              P2 = PSOFT1(2,INDXS+2)
              P3 = PSOFT1(3,INDXS+2)
              P4 = PSOFT1(4,INDXS+2)
              IJSI1(INDXS+2) = -IJH
            ELSE
              P1 = PSOFT2(1,INDXS+2)
              P2 = PSOFT2(2,INDXS+2)
              P3 = PSOFT2(3,INDXS+2)
              P4 = PSOFT2(4,INDXS+2)
              IJSI2(INDXS+2) = -IJH
            ENDIF
C  registration
            CALL REGPAR(-1,-IJH,0,JM1,JM2,P1,P2,P3,P4,
     &                    IHP,0,ICA1,0,IPOS,1)
            IUSED = 3
          ELSE IF(IVAL.EQ.-1) THEN
C  only sea quark engaged
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(IJH.GT.0) THEN
              ICC1 = ICB1
              ICB1 = ICA1
              ICA1 = ICC1
            ENDIF
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = -IJH
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = -IJH
            ENDIF
C  registration
            CALL REGPAR(-1,-IJH,0,JM1,JM2,P1,P2,P3,P4,
     &                    IHP,0,ICA1,0,IPOS,1)
            CALL QUASTA(-IJH,IDHEP(JM1),5)
            IUSED = 1
          ELSE
            WRITE(6,'(1X,A,2I5)')
     &        'POHREM:ERROR:UNSUPPORTED COMBINATION OF IVAL,IJH',
     &        IVAL,IJH
            CALL POABRT
          ENDIF
C
          IC1 = ICB1
          IC2 = 0
C
C  gluon
        ELSE
          IF(IVAL.EQ.1) THEN
C  gluon from valence quarks
            CALL VALFLA(JM1,IFL1,IFL2,PHEP(5,JM1))
            CALL QUASTA(IFL1,IDHEP(JM1),1)
            CALL QUASTA(IFL2,IDHEP(JM1),1)
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(((ABS(IFL1).LE.6).AND.(IFL1.LT.0))
     &         .OR.((ABS(IFL1).GT.6).AND.(IFL1.GT.0))) THEN
              I = ICA1
              ICA1 = ICB1
              ICB1 = I
            ENDIF
            IF(RNDM(P2).LT.OHALF) THEN
              CALL SELCOL(ICA1,ICA2,ICA1,ICA2,ICC1,ICC2,2)
            ELSE
              CALL SELCOL(ICB1,ICB2,ICB1,ICB2,ICC1,ICC2,2)
            ENDIF
C  remainder of hadron
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = IFL1
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = IFL1
            ENDIF
C  registration
            CALL REGPAR(-1,IFL1,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICA1,IVSW,IPOS,1)
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+1)
              P2 = PSOFT1(2,INDXS+1)
              P3 = PSOFT1(3,INDXS+1)
              P4 = PSOFT1(4,INDXS+1)
              IJSI1(INDXS+1) = IFL2
            ELSE
              P1 = PSOFT2(1,INDXS+1)
              P2 = PSOFT2(2,INDXS+1)
              P3 = PSOFT2(3,INDXS+1)
              P4 = PSOFT2(4,INDXS+1)
              IJSI2(INDXS+1) = IFL2
            ENDIF
C  registration
            CALL REGPAR(-1,IFL2,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICB1,IVSW,IPOS,1)
C
            IUSED = 2
          ELSE IF(IVAL.EQ.0) THEN
C  gluon from sea quarks connected with valence quarks
            CALL VALFLA(JM1,IFL1,IFL2,PHEP(5,JM1))
            CALL QUASTA(IFL1,IDHEP(JM1),1)
            CALL QUASTA(IFL2,IDHEP(JM1),1)
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(((ABS(IFL1).LE.6).AND.(IFL1.LT.0))
     &         .OR.((ABS(IFL1).GT.6).AND.(IFL1.GT.0))) THEN
              I = ICA1
              ICA1 = ICB1
              ICB1 = I
            ENDIF
            IF(RNDM(P3).LT.OHALF) THEN
              CALL SELCOL(ICA1,ICA2,ICA1,ICA2,ICC1,ICC2,2)
            ELSE
              CALL SELCOL(ICB1,ICB2,ICB1,ICB2,ICC1,ICC2,2)
            ENDIF
C  remainder of hadron
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = IFL1
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = IFL1
            ENDIF
C  registration
            CALL REGPAR(-1,IFL1,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICA1,IVSW,IPOS,1)
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+1)
              P2 = PSOFT1(2,INDXS+1)
              P3 = PSOFT1(3,INDXS+1)
              P4 = PSOFT1(4,INDXS+1)
              IJSI1(INDXS+1) = IFL2
            ELSE
              P1 = PSOFT2(1,INDXS+1)
              P2 = PSOFT2(2,INDXS+1)
              P3 = PSOFT2(3,INDXS+1)
              P4 = PSOFT2(4,INDXS+1)
              IJSI2(INDXS+1) = IFL2
            ENDIF
C  registration
            CALL REGPAR(-1,IFL2,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICB1,IVSW,IPOS,1)
C  sea quark pair
            CALL SEAFLA(JM1,IFL1,IFL2,CUTMU(1))
            CALL QUASTA(IFL1,IDHEP(JM1),3)
            CALL QUASTA(IFL2,IDHEP(JM2),3)
            IF(ICC1.GT.0) THEN
              IFL1 = ABS(IFL1)
              IFL2 = -IFL1
            ELSE
              IFL1 = -ABS(IFL1)
              IFL2 = -IFL1
            ENDIF
            IF(RNDM(P4).LT.OHALF) THEN
              ICB1 = ICC2
              CALL SELCOL(ICC1,0,ICA1,ICA2,ICC1,ICC2,2)
            ELSE
              ICA1 = ICC1
              CALL SELCOL(ICC2,0,ICB1,ICB2,ICC1,ICC2,2)
            ENDIF
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+2)
              P2 = PSOFT1(2,INDXS+2)
              P3 = PSOFT1(3,INDXS+2)
              P4 = PSOFT1(4,INDXS+2)
              IJSI1(INDXS+2) = IFL1
            ELSE
              P1 = PSOFT2(1,INDXS+2)
              P2 = PSOFT2(2,INDXS+2)
              P3 = PSOFT2(3,INDXS+2)
              P4 = PSOFT2(4,INDXS+2)
              IJSI2(INDXS+2) = IFL1
            ENDIF
C  registration
            CALL REGPAR(-1,IFL1,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICA1,0,IPOS,1)
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS+3)
              P2 = PSOFT1(2,INDXS+3)
              P3 = PSOFT1(3,INDXS+3)
              P4 = PSOFT1(4,INDXS+3)
              IJSI1(INDXS+3) = IFL2
            ELSE
              P1 = PSOFT2(1,INDXS+3)
              P2 = PSOFT2(2,INDXS+3)
              P3 = PSOFT2(3,INDXS+3)
              P4 = PSOFT2(4,INDXS+3)
              IJSI2(INDXS+3) = IFL2
            ENDIF
C  registration
            CALL REGPAR(-1,IFL2,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICB1,0,IPOS,1)
C
            IUSED = 4
          ELSE IF(IVAL.EQ.-1) THEN
C  gluon from sea quarks
            CALL SEAFLA(JM1,IFL1,IFL2,CUTMU(1))
            CALL QUASTA(IFL1,IDHEP(JM1),3)
            CALL QUASTA(IFL2,IDHEP(JM2),3)
            CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
            IF(((ABS(IFL1).LE.6).AND.(IFL1.LT.0))
     &         .OR.((ABS(IFL1).GT.6).AND.(IFL1.GT.0))) THEN
              I = ICA1
              ICA1 = ICB1
              ICB1 = I
            ENDIF
            IF(RNDM(P1).LT.OHALF) THEN
              CALL SELCOL(ICA1,ICA2,ICA1,ICA2,ICC1,ICC2,2)
            ELSE
              CALL SELCOL(ICB1,ICB2,ICB1,ICB2,ICC1,ICC2,2)
            ENDIF
C  remainder of hadron
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS)
              P2 = PSOFT1(2,INDXS)
              P3 = PSOFT1(3,INDXS)
              P4 = PSOFT1(4,INDXS)
              IJSI1(INDXS) = IFL1
            ELSE
              P1 = PSOFT2(1,INDXS)
              P2 = PSOFT2(2,INDXS)
              P3 = PSOFT2(3,INDXS)
              P4 = PSOFT2(4,INDXS)
              IJSI2(INDXS) = IFL1
            ENDIF
C  registration
            CALL REGPAR(-1,IFL1,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICA1,ICA2,IPOS,1)
C  remainder of sea
            IF(INDXH.GT.0) THEN
              P1 = PSOFT1(1,INDXS-1)
              P2 = PSOFT1(2,INDXS-1)
              P3 = PSOFT1(3,INDXS-1)
              P4 = PSOFT1(4,INDXS-1)
              IJSI1(INDXS-1) = IFL2
            ELSE
              P1 = PSOFT2(1,INDXS-1)
              P2 = PSOFT2(2,INDXS-1)
              P3 = PSOFT2(3,INDXS-1)
              P4 = PSOFT2(4,INDXS-1)
              IJSI2(INDXS-1) = IFL2
            ENDIF
C  registration
            CALL REGPAR(-1,IFL2,0,JM1,JM2,P1,P2,P3,P4,
     &                  IHP,0,ICB1,ICB2,IPOS,1)
C
            IUSED = 2
          ELSE
            WRITE(6,'(1X,A,2I5)')
     &        'POHREM:ERROR:UNSUPPORTED COMBINATION OF IVAL,IJH',
     &        IVAL,IJH
            CALL POABRT
          ENDIF
          IC1 = ICC1
          IC2 = ICC2
        ENDIF
      END
