C
C
      SUBROUTINE POHSCA(IMODE,IP)
C**********************************************************************
C
C     POHSCA determines the type of hard subprocess, the partons taking
C     part in subprocess and the kinematic variables
C
C     input:  IMODE   1   direct processes
C                     2   resolved processes
C                     -1  initialization
C                     -2  output of statistics
C             IP      1-4 level of hard interaction (hadron/photon)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER( ZERO = 0.D0,
     &           ONE  = 1.D0,
     &           EPS  = 1.D-10,
     &           DEPS = 1.D-30,
     &           TWO  = 2.D0 )
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      PARAMETER ( MAXPRO = 16 , MLINE = 400 , MSCAHD = 50 )
      COMMON /HAPARA/ ALPHAS,Q0SQR,ALASQR,BQCD,NPD,NF,NHA,NHB
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      CHARACTER*18 PROC
      COMMON /PEPROC/ PROC(0:MAXPRO)
      COMMON /HAEVNT/ PT1,PT2,NHARD,NTRY,IHARD,ITRY,IREJEV
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      DIMENSION PDA(-6:6),PDB(-6:6)
      COMMON /HAEVTR/ LINE,LIN,LREC1(MLINE),LREC2(MLINE),PREC(4,MLINE)
      INTEGER MXSECT
      PARAMETER ( MAXTAB = 20 )
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
C
 111  CONTINUE
C  resolved processes
      IF(IMODE.EQ.2) THEN
        MXSECT(0,0,IP) = 0
        XSECT(2,9)  = 0.D0
        DO 15 M=-1,8
          IF(MXSECT(0,M,IP).EQ.1) XSECT(2,9) = XSECT(2,9)+XSECT(2,M)
 15     CONTINUE
        IF(XSECT(2,9).LT.DEPS) THEN
          WRITE(6,'(/1X,A,I4)') 'POHSCA:ERROR:NO RES.PROCESS(IP)',IP
          CALL POABRT
        ENDIF
C
C ----------------------------------------------I
C  begin of iteration loop (resolved processes) I
C                                               I
        IREJSC = 0
 10     CONTINUE
        IREJSC = IREJSC+1
        IREJEV = IREJEV+1
C  find subprocess
        B      = RNDM(X1)*XSECT(2,9)
        MSPR   =-2
        SUM    = 0.D0
 20     MSPR   = MSPR+1
        IF ( MXSECT(0,MSPR,IP).EQ.1 ) SUM = SUM+XSECT(2,MSPR)
        IF ( SUM.LT.B  .AND. MSPR.LT.8 ) GOTO 20
C  find kin. variables X1,X2 and V
        CALL POHKIN(IREJ)
        IF(IREJ.NE.0) THEN
          IFAIL(29) = IFAIL(29)+1
          IF(IREJSC.GT.100) THEN
            WRITE(6,'(/1X,A,I10)')
     &        'POHSCA:ERROR:TOO MANY REJECTIONS (resolved)',IREJSC
              CALL POABRT
          ENDIF
          GOTO 10
        ENDIF
C  calculate remaining distribution
        CALL POHWGH(PDS,PDA,PDB,F)
C  actualize counter for cross-section calculation
        IF( F .LE. 1.D-40 ) F=0.D0
        XSECT(5,MSPR) = XSECT(5,MSPR)+F
        XSECT(6,MSPR) = XSECT(6,MSPR)+F*F
        MXSECT(1,MSPR,IP) = MXSECT(1,MSPR,IP)+1
C  check F against FMAX
        WEIGHT = F/(XSECT(2,MSPR)+DEPS)
        IF ( WEIGHT.LT.RNDM(X2) ) GOTO 10
C-------------------------------------------------------------------
         IF(WEIGHT.GT.1.D0) THEN
           WRITE(6,1234) MSPR,IP,IDPDG1,IDPDG2,F,XSECT(2,MSPR),WEIGHT
 1234      FORMAT(/,' POHSCA:WARNING:(resolved) W>1 (MSPR,IP,ID1,2)',
     &       2I3,2I7,/' F,XSECT(2,MSPR),W',3E12.4)
           WRITE(6,'(1X,A,5E11.3)') 'ECM,PTWANT,AS,AH,PT',
     &       ECMP,PTWANT,AS,AH,PT
           WRITE(6,'(1X,A,5E11.3)') 'ETAC,ETAD,X1,X2,V',
     &       ETAC,ETAD,X1,X2,V
           CALL POPREV(-1)
         ENDIF
C-------------------------------------------------------------------
C                                             I
C  end of iteration loop (resolved processes) I
C --------------------------------------------I
C
C*********************************************************************
C
C  direct processes
      ELSE IF(IMODE.EQ.1) THEN
        XSECT(2,15)  = 0.D0
        DO 25 M= 10,14
          IF(MXSECT(0,M,IP).EQ.1) XSECT(2,15)=XSECT(2,15)+XSECT(2,M)
 25     CONTINUE
        IF(XSECT(2,15).LT.DEPS) THEN
          WRITE(6,'(/1X,A,I4)') 'POHSCA:ERROR:NO DIR.PROCESS(IP)',IP
          CALL POABRT
        ENDIF
C
C ----------------------------------------------I
C  begin of iteration loop (direct processes)   I
C                                               I
        IREJSC = 0
 100    CONTINUE
        IREJSC = IREJSC+1
        IREJEV = IREJEV+1
C  find subprocess
        B      = RNDM(X1)*XSECT(2,15)
        MSPR   = 9
        SUM    = 0.D0
 200    MSPR   = MSPR+1
        IF(MXSECT(0,MSPR,IP).EQ.1) SUM = SUM+XSECT(2,MSPR)
        IF ( SUM.LT.B  .AND. MSPR.LT.14 ) GOTO 200
C  find kin. variables X1,X2 and V
        CALL POHKIN(IREJ)
        IF(IREJ.NE.0) THEN
          IFAIL(28) = IFAIL(28)+1
          IF(IREJSC.GT.1000) THEN
            WRITE(6,'(/1X,A,I10)')
     &        'POHSCA:ERROR:TOO MANY REJECTIONS (direct)',IREJSC
              CALL POABRT
          ENDIF
          GOTO 100
        ENDIF
C  calculate remaining distribution
        CALL POHWGH(PDS,PDA,PDB,F)
C  actualize counter for cross-section calculation
        IF( F .LE. 1.D-15 ) F=0.D0
        XSECT (5,MSPR) = XSECT (5,MSPR)+F
        XSECT (6,MSPR) = XSECT (6,MSPR)+F*F
        MXSECT(1,MSPR,IP) = MXSECT(1,MSPR,IP)+1
C  check F against FMAX
        WEIGHT = F/(XSECT(2,MSPR)+DEPS)
        IF ( WEIGHT.LT.RNDM(X2) ) GOTO 100
C-------------------------------------------------------------------
         IF(WEIGHT.GT.1.D0) THEN
           WRITE(6,1235) MSPR,IP,IDPDG1,IDPDG2,F,XSECT(2,MSPR),WEIGHT
 1235      FORMAT(/,' POHSCA:WARNING:(direct) W>1 (MSPR,IP,ID1,2)',2I3,
     &       2I7,/' F,XSECT(2,MSPR),W',3E12.4)
           WRITE(6,'(1X,A,5E11.3)') 'ECM,PTWANT,AS,AH,PT',
     &       ECMP,PTWANT,AS,AH,PT
           WRITE(6,'(1X,A,5E11.3)') 'ETAC,ETAD,X1,X2,V',
     &       ETAC,ETAD,X1,X2,V
           CALL POPREV(-1)
         ENDIF
C-------------------------------------------------------------------
C                                             I
C  end of iteration loop (direct processes)   I
C --------------------------------------------I
C
C  initialization
      ELSE IF(IMODE.EQ.-1) THEN
C  initialize cross section calculations
        DO 40 M=-1,MAXPRO
          DO 30 I=5,6
            XSECT(I,M) = ZERO
 30       CONTINUE
          DO 35 J=1,4
C  reset counters
            MXSECT(1,M,J) = 0
            MXSECT(2,M,J) = 0
 35       CONTINUE
 40     CONTINUE
        IF(IDEB(78).GE.0) THEN
          WRITE(6,'(/1X,A,/1X,A)')
     &      'POHSCA:DEBUG:ACTIVATED HARD PROCESSES',
     &      '====================================='
          WRITE(6,'(5X,A)') 'PROCESS,    IP= 1 ... 4 (on/off)'
          DO 42 M=1,MAXPRO
            WRITE(6,'(1X,I3,5X,A,4I3)') M,PROC(M),(MXSECT(0,M,J),J=1,4)
 42       CONTINUE
        ENDIF
        RETURN
      ELSE IF(IMODE.EQ.-2) THEN
        DO 43 K=1,4
          DO 44 J=1,4
            MXSECT(J,0,K)  = 0
            MXSECT(J,9,K)  = 0
            MXSECT(J,15,K) = 0
            MXSECT(J,3,K) = MXSECT(J,3,K)+MXSECT(J,-1,K)
            DO 45 M=1,8
              MXSECT(J,9,K) = MXSECT(J,9,K)+MXSECT(J,M,K)
 45         CONTINUE
            DO 46 M=10,14
              MXSECT(J,15,K) = MXSECT(J,15,K)+MXSECT(J,M,K)
 46         CONTINUE
            MXSECT(J,0,K) = MXSECT(J,9,K)+MXSECT(J,15,K)
 44       CONTINUE
 43     CONTINUE
        IF(IDEB(78).GE.1) THEN
          WRITE(6,'(/1X,A,/1X,A)')
     &      'POHSCA:DEBUG:INTERNAL REJECTION STATISTICS',
     &      '=========================================='
          DO 48 K=1,4
            IF(MXSECT(1,0,K).GT.0) THEN
              WRITE(6,'(5X,A,I3)')
     &          'PROCESS (SAMPLED/ACCEPTED) FOR IP:',K
              DO 47 M=0,MAXPRO
                WRITE(6,'(1X,I3,1X,A,2X,2I12,3F9.3)') M,PROC(M),
     &            MXSECT(1,M,K),MXSECT(2,M,K),(DBLE(MXSECT(J,M,K))
     &            /DBLE(MAX(1,MXSECT(J-1,M,K))),J=2,4)
 47           CONTINUE
            ENDIF
 48       CONTINUE
        ENDIF
        RETURN
      ELSE
        WRITE(6,'(/1X,A,I10)') 'POHSCA:ERROR:UNSUPPORTED MODE',IMODE
        CALL POABRT
      ENDIF
C
C  the event is accepted now
C  actualize counter for accepted events
      MXSECT(2,MSPR,IP) = MXSECT(2,MSPR,IP)+1
      IF(MSPR.EQ.-1) MSPR = 3
C
C  find initial partons
      SUM    = 0.D0
      SCHECK = RNDM(SUM)*PDS-EPS
      IF     ( MSPR.EQ.1  .OR.  MSPR.EQ.4 ) THEN
        IA = 0
        IB = 0
      ELSEIF ( MSPR.EQ.2  .OR.  MSPR.EQ.5  .OR.  MSPR.EQ.6 ) THEN
        DO 610 IA=-NF,NF
          IF ( IA.EQ.0 ) GOTO 610
          SUM  = SUM+PDA(IA)*PDB(-IA)
          IF ( SUM.GE.SCHECK ) GOTO 620
 610      CONTINUE
 620    IB =-IA
      ELSEIF ( MSPR.EQ.3 ) THEN
        IB     = 0
        DO 630 IA=-NF,NF
          IF ( IA.EQ.0 ) GOTO 630
          SUM  = SUM+PDA(0)*PDB(IA)
          IF ( SUM.GE.SCHECK ) GOTO 640
          SUM  = SUM+PDA(IA)*PDB(0)
          IF ( SUM.GE.SCHECK ) GOTO 650
 630    CONTINUE
 640    IB     = IA
        IA     = 0
 650    CONTINUE
      ELSEIF ( MSPR.EQ.7 ) THEN
        DO 660 IA=-NF,NF
          IF ( IA.EQ.0 ) GOTO 660
          SUM  = SUM+PDA(IA)*PDB(IA)
          IF ( SUM.GE.SCHECK ) GOTO 670
 660      CONTINUE
 670    IB     = IA
      ELSEIF ( MSPR.EQ.8 ) THEN
        DO 690 IA=-NF,NF
          IF ( IA.EQ.0 ) GOTO 690
          DO 680 IB=-NF,NF
            IF ( ABS(IB).EQ.ABS(IA)  .OR.  IB.EQ.0 ) GOTO 680
            SUM = SUM+PDA(IA)*PDB(IB)
            IF ( SUM.GE.SCHECK ) GOTO 700
 680        CONTINUE
 690      CONTINUE
 700    CONTINUE
      ELSEIF ( MSPR.EQ.10 ) THEN
        IA     = 0
        DO 710 IB=-NF,NF
          IF ( IB.NE.0 ) THEN
            IF(IDPDG1.EQ.22) THEN
              IF(MOD(ABS(IB),2).EQ.0) THEN
                SUM = SUM+PDB(IB)*4.D0/9.D0
              ELSE
                SUM = SUM+PDB(IB)*1.D0/9.D0
              ENDIF
            ELSE
              SUM = SUM+PDB(IB)
            ENDIF
            IF ( SUM.GE.SCHECK ) GOTO 720
          ENDIF
 710    CONTINUE
 720    CONTINUE
      ELSEIF ( MSPR.EQ.12 ) THEN
        IB     = 0
        DO 810 IA=-NF,NF
          IF ( IA.NE.0 ) THEN
            IF(IDPDG2.EQ.22) THEN
              IF(MOD(ABS(IA),2).EQ.0) THEN
                SUM = SUM+PDA(IA)*4.D0/9.D0
              ELSE
                SUM = SUM+PDA(IA)*1.D0/9.D0
              ENDIF
            ELSE
              SUM = SUM+PDA(IA)
            ENDIF
            IF ( SUM.GE.SCHECK ) GOTO 820
          ENDIF
 810    CONTINUE
 820    CONTINUE
      ELSEIF ((MSPR.EQ.11).OR.(MSPR.EQ.13).OR.(MSPR.EQ.14)) THEN
        IA     = 0
        IB     = 0
      ENDIF
C  final check
      IF((ABS(IA).GT.NF).OR.(ABS(IB).GT.NF)) THEN
        print *,' final check IA,IB',IA,IB
        GOTO 111
      ENDIF
C
C  find final partons
      IC = IA
      ID = IB
      IF     ( MSPR.EQ.2 ) THEN
        IC = 0
        ID = 0
      ELSEIF ( MSPR.EQ.4 ) THEN
        IC = INT(FLOAT(NF+NF)*RNDM(SUM))+1
        IF ( IC.GT.NF ) IC = NF-IC
        ID =-IC
      ELSEIF ( MSPR.EQ.6 ) THEN
        IC = INT(FLOAT(NF+NF-2)*RNDM(SUM))+1
        IF ( IC.GT.NF-1 ) IC = NF-1-IC
        IF ( ABS(IC).EQ.ABS(IA) ) IC = SIGN(NF,IC)
        ID =-IC
      ELSEIF ( MSPR.EQ.11) THEN
        SUM = 0.D0
        DO 730 IC=-NF,NF
          IF ( IC.NE.0 ) THEN
            IF(IDPDG1.EQ.22) THEN
              IF(MOD(ABS(IC),2).EQ.0) THEN
                SUM = SUM + 4.D0
              ELSE
                SUM = SUM + 1.D0
              ENDIF
            ELSE
              SUM = SUM + 1.D0
            ENDIF
          ENDIF
 730    CONTINUE
        SCHECK = RNDM(SUM)*SUM-EPS
        SUM = 0.D0
        DO 740 IC=-NF,NF
          IF ( IC.NE.0 ) THEN
            IF(IDPDG1.EQ.22) THEN
              IF(MOD(ABS(IC),2).EQ.0) THEN
                SUM = SUM + 4.D0
              ELSE
                SUM = SUM + 1.D0
              ENDIF
            ELSE
              SUM = SUM + 1.D0
            ENDIF
            IF ( SUM.GE.SCHECK ) GOTO 750
          ENDIF
 740    CONTINUE
 750    CONTINUE
        ID = -IC
      ELSEIF ( MSPR.EQ.13) THEN
        SUM = 0.D0
        DO 830 IC=-NF,NF
          IF ( IC.NE.0 ) THEN
            IF(IDPDG2.EQ.22) THEN
              IF(MOD(ABS(IC),2).EQ.0) THEN
                SUM = SUM + 4.D0
              ELSE
                SUM = SUM + 1.D0
              ENDIF
            ELSE
              SUM = SUM + 1.D0
            ENDIF
          ENDIF
 830    CONTINUE
        SCHECK = RNDM(SUM)*SUM-EPS
        SUM = 0.D0
        DO 840 IC=-NF,NF
          IF ( IC.NE.0 ) THEN
            IF(IDPDG2.EQ.22) THEN
              IF(MOD(ABS(IC),2).EQ.0) THEN
                SUM = SUM + 4.D0
              ELSE
                SUM = SUM + 1.D0
              ENDIF
            ELSE
              SUM = SUM + 1.D0
            ENDIF
            IF ( SUM.GE.SCHECK ) GOTO 850
          ENDIF
 840    CONTINUE
 850    CONTINUE
        ID = -IC
      ELSEIF ( MSPR.EQ.14) THEN
        SUM = 0.D0
        DO 930 IC=1,NF
          FAC1 = 1.D0
          FAC2 = 1.D0
          IF(MOD(ABS(IC),2).EQ.0) THEN
            IF(IDPDG1.EQ.22) FAC1 = 4.D0
            IF(IDPDG2.EQ.22) FAC2 = 4.D0
          ENDIF
          SUM = SUM + FAC1*FAC2
 930    CONTINUE
        IF(IPAMDL(64).NE.0) THEN
          IF((IDPDG1.EQ.22).AND.(IDPDG2.EQ.22)) SUM = SUM + 81.D0
        ENDIF
        SCHECK = RNDM(SUM)*SUM-EPS
        SUM = 0.D0
        DO 940 IC=1,NF
          FAC1 = 1.D0
          FAC2 = 1.D0
          IF(MOD(ABS(IC),2).EQ.0) THEN
            IF(IDPDG1.EQ.22) FAC1 = 4.D0
            IF(IDPDG2.EQ.22) FAC2 = 4.D0
          ENDIF
          SUM = SUM + FAC1*FAC2
          IF ( SUM.GE.SCHECK ) GOTO 950
 940    CONTINUE
        IC = 15
 950    CONTINUE
        ID = -IC
        IF(RNDM(FAC1).GT.0.5D0) CALL SWAPI(IC,ID)
      ENDIF
      XM3 = POPAMA(IC,1)
      XM4 = POPAMA(ID,1)
      IF(ABS(IC).EQ.15) GOTO 955
C
C  valence quarks involved?
      IF(IA.NE.0) THEN
        IF(IDPDG1.EQ.22) THEN
          CALL POPDFB(IA,X1,QQPD,PVIRTP(1),FXP)
          IF(RNDM(XM3)*PDA(IA).GT.PDA(IA)-FXP) IA=SIGN(ABS(IA)+6,IA)
        ELSE
          IF(RNDM(XM3)*PDA(IA).GT.PDA(-IA)) IA = SIGN(ABS(IA)+6,IA)
        ENDIF
      ENDIF
      IF(IB.NE.0) THEN
        IF(IDPDG2.EQ.22) THEN
          CALL POPDFB(IB,X2,QQPD,PVIRTP(2),FXP)
          IF(RNDM(XM4)*PDB(IB).GT.PDB(IB)-FXP) IB=SIGN(ABS(IB)+6,IB)
        ELSE
          IF(RNDM(XM4)*PDB(IB).GT.PDB(-IB)) IB = SIGN(ABS(IB)+6,IB)
        ENDIF
      ENDIF
C  fill event record
 955  CONTINUE
      CALL SFECFE(SINPHI,COSPHI)
      ECM2 = ECMP/2.D0
C
      LINE          = LINE+1
      PREC(1,LINE)  = 0.D0
      PREC(2,LINE)  = 0.D0
      PREC(3,LINE)  = ECM2*X1
      PREC(4,LINE)  = PREC(3,LINE)
      LREC1(LINE)   = IA+50+100*MSPR
      LREC2(LINE)   = 01000
      LINE          = LINE+1
      PREC(1,LINE)  = 0.D0
      PREC(2,LINE)  = 0.D0
      PREC(3,LINE)  =-ECM2*X2
      PREC(4,LINE)  =-PREC(3,LINE)
      LREC1(LINE)   = IB+50
      LREC2(LINE)   = 01000
      LINE          = LINE+1
      PREC(1,LINE)  = PT*COSPHI
      PREC(2,LINE)  = PT*SINPHI
      PREC(3,LINE)  = -ECM2*(U*X1-V*X2)
      PREC(4,LINE)  = -ECM2*(U*X1+V*X2)
      LREC1(LINE)   = IC+50
      LREC2(LINE)   = 11000
      LINE          = LINE+1
      PREC(1,LINE)  = -PREC(1,LINE-1)
      PREC(2,LINE)  = -PREC(2,LINE-1)
      PREC(3,LINE)  = -ECM2*(V*X1-U*X2)
      PREC(4,LINE)  = -ECM2*(V*X1+U*X2)
      LREC1(LINE)   = ID+50
      LREC2(LINE)   = 11000
C  convert to mass shell
      CALL MSHELL(PREC(1,LINE-1),PREC(1,LINE),XM3,XM4,
     &  PREC(1,LINE-1),PREC(1,LINE),IREJ)
      IF(IREJ.NE.0) THEN
        IF(IDEB(78).GE.5) WRITE(6,'(1X,A,3E12.4)')
     &    'POHSCA:WARNING:MSHELL REJECTION (PT,M1,M2)',PT,XM3,XM4
        LINE = LINE-4
        GOTO 111
      ENDIF
C  debug output
      IF(IDEB(78).GE.20) THEN
        SHAT = X1*X2*ECMP*ECMP
        WRITE(6,'(1X,A,4I4)') 'POHSCA:DEBUG:IA,IB,IC,ID',IA,IB,IC,ID
        WRITE(6,'(5X,A,I4,2E11.3)') 'LINE, INITIAL X ',LINE,X1,X2
        WRITE(6,'(5X,A,4E11.3)') 'U,V,PT,SHAT ',U,V,PT,SHAT
      ENDIF
      END
