C
C
      SUBROUTINE POLUIN(IDEFAU)
C***********************************************************************
C
C     initialization for JETSET call in DTUNUC 1.04 (J.R. 6/93)
C                      changed to work in PHOJET   (R.E. 1/94)
C
C     input:  IDEFAU    0  no hadronization at all
C                       1  do not touch any parameter of JETSET
C                       2  default parameters kept, decay length 10mm to
C                          define stable particles
C                       3  load tuned parameters for JETSET 7.3
C             neg. value:  prevent strange/charm hadrons from decaying
C
C     ATTENTION: single precision interface to JETSET
C                may be JETSET version dependent
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (EPS=1.D-10)
C
**sr 29.04. commented to use dp-JETSET
      REAL  P,V
**sr 29.04. LUJETS array-dimensions increased
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
C     COMMON/LUJETS/N,K(8000,5),P(8000,5),V(8000,5)
**sr 29.04. commented to use dp-JETSET
      REAL  PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
**sr 29.04. commented to use dp-JETSET
      REAL  PMAS,PARF,VCKM
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
**sr 29.04. commented to use dp-JETSET
      REAL  BRAT
      COMMON/LUDAT3/MDCY(500,3),MDME(2000,2),BRAT(2000),KFDP(2000,5)
C
      IDEFAB = ABS(IDEFAU)
C
      IF(IDEFAB.EQ.0) THEN
        WRITE(6,'(/1X,A)') 'POLUIN:DEBUG:HADRONIZATION SWITCHED OFF'
        RETURN
      ENDIF
C
C  declare stable particles
      IF(IDEFAB.GE.2) MSTJ(22) = 2
C
C  load optimized parameters
      IF(IDEFAB.GE.3) THEN
C  switch popcorn off
**sr comment this
        MSTJ(12) = 1
**
*       PARJ(19)=0.19
C  Lund a-parameter
C  (default=0.3)
        PARJ(41)=0.3
C  Lund b-parameter
C  (default=1.0)
        PARJ(42)=1.0
C  Lund sigma parameter in pt distribution
C  (default=0.36)
        PARJ(21)=0.36
      ENDIF
C
C  prevent particles decaying
      IF(IDEFAU.LT.0) THEN
C                 KOS
        KC=LUCOMP(310)
        MDCY(KC,1)=0
C                 PIO
        KC=LUCOMP(111)
        MDCY(KC,1)=0
C                 LAMBDA
        KC=LUCOMP(3122)
        MDCY(KC,1)=0
C                 ALAMBDA
        KC=LUCOMP(-3122)
        MDCY(KC,1)=0
C                 SIG+
        KC=LUCOMP(3222)
        MDCY(KC,1)=0
C                 ASIG+
        KC=LUCOMP(-3222)
        MDCY(KC,1)=0
C                 SIG-
        KC=LUCOMP(3112)
        MDCY(KC,1)=0
C                 ASIG-
        KC=LUCOMP(-3112)
        MDCY(KC,1)=0
C                 SIG0
        KC=LUCOMP(3212)
        MDCY(KC,1)=0
C                 ASIG0
        KC=LUCOMP(-3212)
        MDCY(KC,1)=0
C                 TET0
        KC=LUCOMP(3322)
        MDCY(KC,1)=0
C                 ATET0
        KC=LUCOMP(-3322)
        MDCY(KC,1)=0
C                 TET-
        KC=LUCOMP(3312)
        MDCY(KC,1)=0
C                 ATET-
        KC=LUCOMP(-3312)
        MDCY(KC,1)=0
C                 OMEGA-
        KC=LUCOMP(3334)
        MDCY(KC,1)=0
C                 AOMEGA-
        KC=LUCOMP(-3334)
        MDCY(KC,1)=0
C                 D+
        KC=LUCOMP(411)
        MDCY(KC,1)=0
C                 D-
        KC=LUCOMP(-411)
        MDCY(KC,1)=0
C                 D0
        KC=LUCOMP(421)
        MDCY(KC,1)=0
C                 A-D0
        KC=LUCOMP(-421)
        MDCY(KC,1)=0
C                 DS+
        KC=LUCOMP(431)
        MDCY(KC,1)=0
C                 A-DS+
        KC=LUCOMP(-431)
        MDCY(KC,1)=0
C                ETAC
        KC=LUCOMP(441)
        MDCY(KC,1)=0
C                LAMBDAC+
        KC=LUCOMP(4122)
        MDCY(KC,1)=0
C                A-LAMBDAC+
        KC=LUCOMP(-4122)
        MDCY(KC,1)=0
C                SIGMAC++
        KC=LUCOMP(4222)
        MDCY(KC,1)=0
C                SIGMAC+
        KC=LUCOMP(4212)
        MDCY(KC,1)=0
C                SIGMAC0
        KC=LUCOMP(4112)
        MDCY(KC,1)=0
C                A-SIGMAC++
        KC=LUCOMP(-4222)
        MDCY(KC,1)=0
C                A-SIGMAC+
        KC=LUCOMP(-4212)
        MDCY(KC,1)=0
C                A-SIGMAC0
        KC=LUCOMP(-4112)
        MDCY(KC,1)=0
C                KSIC+
        KC=LUCOMP(4232)
        MDCY(KC,1)=0
C                KSIC0
        KC=LUCOMP(4132)
        MDCY(KC,1)=0
C                A-KSIC+
        KC=LUCOMP(-4232)
        MDCY(KC,1)=0
C                A-KSIC0
        KC=LUCOMP(-4132)
        MDCY(KC,1)=0
      ENDIF
C
      WRITE(6,2355)
     &  IDEFAU,PARJ(2),MSTJ(12),PARJ(19),PARJ(41),PARJ(42),PARJ(21)
 2355 FORMAT( /' POLUIN:DEBUG:JETSET INITIALIZATION',I3/,
     &         ' ==================================',/,
     & '     PARJ( 2) strangeness suppression (0.3)  : ',F10.3,/,
     & '     MSTJ(12) popcorn (2)                    : ',I10,/,
     & '     PARJ(19) popcorn (1.0)                  : ',F10.3,/,
     & '     PARJ(41) Lund a (0.5)                   : ',F10.3,/,
     & '     PARJ(42) Lund b (0.9)                   : ',F10.3,/,
     & '     PARJ(21) sigma in pt distribution (0.35): ',F10.3,/)
*     DO 100 I=1,13
*       WRITE(6,'(1X,A,I3,E12.3)') 'PARU: ',I,PARU(I)
*100  CONTINUE
      END
