  
C*********************************************************************
 
C...PYVETO
C...Interface to UPVETO, which allows user to veto event generation
C...on the parton level, after parton showers but before multiple
C...interactions, beam remnants and hadronization is added.
 
      SUBROUTINE PYVETO(IVETO)
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
 
C...PYTHIA commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYINT1/MINT(400),VINT(400)
      SAVE /PYJETS/,/PYINT1/
C...HEPEVT commonblock.
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
      SAVE /HEPEVT/
 
C...Define longitudinal boost from initiator rest frame to cm frame.
      GAMMA=0.5D0*(VINT(141)+VINT(142))/SQRT(VINT(141)*VINT(142))
      GABEZ=0.5D0*(VINT(141)-VINT(142))/SQRT(VINT(141)*VINT(142))
 
C... Search through the event record for unbranched partons.
      NEVHEP=0
      NHEP=0
      DO 100 I=1,N
        IF(K(I,1).GE.1.AND.K(I,1).LE.10) THEN
C...Copy parton info, boosting momenta along z axis to cm frame.
          NHEP=NHEP+1
          ISTHEP(NHEP)=1
          IDHEP(NHEP)=K(I,2)
          PHEP(1,NHEP)=P(I,1)
          PHEP(2,NHEP)=P(I,2)
          PHEP(3,NHEP)=GAMMA*P(I,3)+GABEZ*P(I,4)
          PHEP(4,NHEP)=GAMMA*P(I,4)+GABEZ*P(I,3)
          PHEP(5,NHEP)=P(I,5)
C...History and vertex info not relevant here and zeroed.
          JMOHEP(1,NHEP)=0
          JMOHEP(2,NHEP)=0
          JDAHEP(1,NHEP)=0
          JDAHEP(2,NHEP)=0
          VHEP(1,NHEP)=0D0
          VHEP(2,NHEP)=0D0
          VHEP(3,NHEP)=0D0
          VHEP(4,NHEP)=0D0
        ENDIF
  100 CONTINUE
 
C...Call user-written routine to decide whether to keep events.
      CALL UPVETO(IVETO)
 
      RETURN
      END
